/******************************************************************************
	wb_t@C										2010 Masaji Kasahara
******************************************************************************/


// s`
#define LED				_LATB5		// dsPICW[LED
#define NJW4800_STBY	_LATA3



// LCD
void delay(unsigned usec);			// usecfBC֐
void lcd_data(int asci);			// P\֐
void lcd_cmd(int cmd);				// R}ho͊֐
void lcd_clear(void);				// S֐
void lcd_str(char *str);			// o͊֐
void lcd_init(void);				// ֐
#define LCD_CURON					lcd_cmd(0x0E);	// J[\I(D=C=1 B=0)
#define LCD_CUROFF					lcd_cmd(0x0C);	// J[\It(D=1 B=C=0)
#define LCD_LOCATE( row, column )	lcd_cmd( lcd_adrbase[row] + column )
extern const int lcd_adrbase[4];	// 4sLCD̍sAhX



// MENU
#define FALSE	0
#define TRUE	1
#define ENA_INTERRUPT	SET_CPU_IPL( 0 )	// 荞݋
#define DIS_INTERRUPT	SET_CPU_IPL( 7 )	// 荞݋֎~

// L[͂̃s`(PORTBŁAL[ڑĂrbg=1)
#define SEL_KEY		0x0100					// SELECT:ڈړ
#define UP_KEY		0x8000					// 
#define DOWN_KEY	0x4000					// 
#define LEFT_KEY	(SEL_KEY|UP_KEY)		// SELECTƁ
#define RIGHT_KEY	(SEL_KEY|DOWN_KEY)		// SELECTƁ

typedef int MENU_VAL;	// lj[̕ϐint^ƂĈ
struct menu_dat{
	enum{ INT_MENU, TOGGLE_MENU, SELECT_MENU, END_OF_MENU }type;
	char *str;
	MENU_VAL *value, max, min;
	int row, column, curpos;
};
void menu(struct menu_dat *menu_dats, int menu_no );



// ̑֐̃vg^Cv錾
void init( void );
char *itoa_f( const char *format_str, long value, char *out );	// menu.cQ

void thermo_cont_PID( void );
