
///////////////////////////////////////////////////////////////////////////////
//	̧ٖ		DcDc1LEDCtrl.c
//	CPU			dsPIC33FJ16GS502
//	e		DCDCް1gp3FLED̋Px𐧌䂷
//	ddl				DC12V
//				io͓d	DC6V
//				io͓d	0.7A
//				ݸގg	300kHz
//	@\		SWONƐݒd܂ŗオ
//				o͓dRV10-1A͈̔͂Őݒł
//				LED̎䗦RV20-100%͈̔͂Őݒł
//				o͓dDC12VɌŒ


#include		"p33FJ16GS502.h"
#include		"DcDc1LEDCtrl.h"


// ޲ ̨ڰ ڼ޽ ݒϸ

_FOSCSEL(FNOSC_FRC)							// RCUI
_FOSC(FCKSM_CSECMD & OSCIOFNC_ON)			// gύXƎg֎~
_FWDT(FWDTEN_OFF)							// ܫޯ ϋ֎~
_FPOR(FPWRT_PWR128)							// ܰؾĎ128msec
_FICD(ICS_PGD1 & JTAGEN_OFF)				// ʐM@̐ݒ


///////////////////////////////////////////////////////////////////////////////
// Ҳ݊֐		int main(void)
// 			Ȃ
// ߂l		int
// Tv			main۸

int main(void)
{
// 

	InitCLK();							// ۯ̏
	InitIO();							// IO߰Ă̏
	InitTM();							// TM1,2̏
	InitADC();							// ADC̏
	InitPWM1();							// PWM1̏
	InitInt();							// 荞݊֌W
	InitLED1CtrlVariable();				// LEDɕKvȕϐ̏

	T1CONbits.TON = 1;					// TM1n
	T2CONbits.TON = 1;					// TM2n
	ADCONbits.ADON = 1;					// ADϊJn

	while(1){
		SetCurrDutyRef();				// ϒRldƎ䗦ɐݒ
		if (shTM1Flags.f100us){			// 100usecۯ
			LED1OnOffCtrl();			// LED ON-OFF۰
			shTM1Flags.f100us = 0;
		}

		if (shTM1Flags.f1ms){			// 1msecۯ
			Sw1OnOffCheck();			// Sw1ON-OFFԂ
			shTM1Flags.f1ms = 0;
		}

		if (shTM1Flags.f10ms){			// 10msecۯ
			LED ^= ON;					// LED10msecON-OFF
			shTM1Flags.f10ms = 0;
		}

		DcDc1ModeChange();				// DcDc1̉^]ԂύX
		DcDc1ModeCtrl();				// DcDc1^]ԂɉĐ
	}
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void InitCLK(void)
// 			Ȃ
// ߂l		Ȃ
// Tv			ۯ֌Wݒ
// 				̊֐̓eϲߎЂ̻۸т̂܂܎gpĂ

void InitCLK(void)
{
	PLLFBD = 41;						// PLL̕ PLLFBD+2=43
	CLKDIVbits.PLLPOST = 0;				// N1 = 2
	CLKDIVbits.PLLPRE = 0;				// N2 = 2

	__builtin_write_OSCCONH(0x01);		// RCUPLLɐݒ
	__builtin_write_OSCCONL(0x01);  	// gύX

	OSCTUNbits.TUN = 1;					// g␳

	while(OSCCONbits.COSC != 0b001);	// PLLɂȂ܂ő҂
	while(OSCCONbits.LOCK != 1);		// PLLۯ܂ő҂

	ACLKCONbits.FRCSEL = 1;				// ⏕UPLLɐݒ
	ACLKCONbits.SELACLK = 1;			// ADCPWM̸ۯpƂĂ̔UI
	ACLKCONbits.APSTSCLR = 7;			// ⏕UH̕1ɐݒ
	ACLKCONbits.ENAPLL = 1;				// PLL

	while(ACLKCONbits.APLLCK != 1);		// PLLۯ܂ő҂
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void InitIO(void)
// 			Ȃ
// ߂l		Ȃ
// Tv			IO

void InitIO(void)
{
// TRISAڼ޽
	TRISAbits.TRISA3  = OUT;			// DD Con STBY

// TRISBڼ޽
	TRISBbits.TRISB1  = OUT;			// LCD DB4
	TRISBbits.TRISB2  = OUT;			// LCD DB5
	TRISBbits.TRISB3  = OUT;			// LCD DB6
	TRISBbits.TRISB4  = OUT;			// LCD DB7
	TRISBbits.TRISB5  = OUT;			// LED
	TRISBbits.TRISB8  = IN;				// SW1
	TRISBbits.TRISB11 = OUT;			// LCD E
	TRISBbits.TRISB12 = OUT;			// LCD RS
	TRISBbits.TRISB14 = IN;				// SW3(UART)
	TRISBbits.TRISB15 = OUT;			// SW2(UART)

// LATAڼ޽
	LATAbits.LATA3  = HIGH;				// DD Con STBY OFF

// LATBڼ޽
	LATBbits.LATB1  = LOW;
	LATBbits.LATB2  = LOW;
	LATBbits.LATB3  = LOW;
	LATBbits.LATB4  = LOW;
	LATBbits.LATB5  = HIGHOFF;			// LED OFF
	LATBbits.LATB8  = LOW;				// SW1
	LATBbits.LATB11 = LOW;
	LATBbits.LATB12 = LOW;
	LATBbits.LATB14 = LOW;				// SW3(UART)
	LATBbits.LATB15 = LOW;				// SW2(UART)
}


///////////////////////////////////////////////////////////////////////////////
//	֐		void InitTM(void)
//			Ȃ
//	߂l		Ȃ
//	Tv		TM1,2ۯƂĎgpł悤ɏݒ肷

void InitTM(void)
{
// Timer1
	TMR1 = 0;						//  TM1ڼ޽

// PR1
	PR1 = TM1_CNT;					// lݒ
	
// T1CON
	T1CONbits.TON   = 0;			// ϒ~ォn
	T1CONbits.TCKPS = 0;			// ؽגl 1:1
	T1CONbits.TCS   = 0;			// ۯI

// Timer2
	TMR2 = 0;						//  TM2ڼ޽

// PR2
	PR2 = TM2_CNT;					// lݒ
	
// T2CON
	T2CONbits.TON   = 0;			// ϒ~ォn
	T2CONbits.TCKPS = 0;			// ؽגl 1:1
	T2CONbits.TCS   = 0;			// ۯI
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void InitADC(void)
// 			Ȃ
// ߂l		Ȃ
// Tv			ADC̏

void InitADC(void)
{
// ADCON ڼ޽

	ADCONbits.ADCS = 3;					// ADC̸ۯ1/4ɐݒ
	ADCONbits.ADON = 0;					// ADϊ~Cォ狖

// ADSTAT ڼ޽

	ADSTAT = 0;							// ԂĂ

// ADPCFG ڼ޽

	ADPCFGbits.PCFG0 = 0;				// AN0(RV1)ADϊ߰Ăɐݒ
	ADPCFGbits.PCFG1 = 0;				// AN1(RV2)ADϊ߰Ăɐݒ
	ADPCFGbits.PCFG2 = 0;				// AN2(DcDc1o͓d)ADϊ߰Ăɐݒ
	ADPCFGbits.PCFG3 = 0;				// AN3(DcDc1o͓d)ADω߰Ăɐݒ

// ADCPC0 ڼ޽

	ADCPC0bits.IRQEN0 = 1;				// AN0,AN1߱ADϊ荞݋
	ADCPC0bits.IRQEN1 = 1;				// AN2,AN3߱ADϊ荞݋
	ADCPC0bits.TRGSRC0 = 0x1F;			// TM2AN0,AN1߱ADωض޿ɐݒ
	ADCPC0bits.TRGSRC1 = 0x04;			// PWM1AN2,AN3߱ADϊض޿ɐݒ
}


/////////////////////////////////////////////////////////////////////////////////
// ֐		void InitPWM1(void)
// 			Ȃ
// ߂l		Ȃ
// Tv			PWM1̏

void InitPWM1(void)
{
// PTCON ڼ޽

	PTCONbits.PTEN = 0;					// PWM~Cォ狖

// PTPER ڼ޽(PWM ڼ޽)

	PTPER = PWM_PERIOD;					// PWM 7.37*2*32*2=944MHz
										// 944MHz/300kHz=3146

// PWMCON1 ڼ޽

	PWMCON1bits.IUE = 1;				// PWMl̑XV
	PWMCON1bits.DTC = 2;				// ޯюgpȂ

// TRIGCON1

	TRGCON1bits.TRGDIV = 0x2;			// 3񖈂ADϊ

// IOCON1 ڼ޽

	IOCON1bits.PENH = 1;				// PWM1HPWMo͂ɐݒ

// PDC1 ڼ޽

	PDC1 = DD1_PWM_MIN;					// ŏlݒ肵Ă

// TRIG1 ڼ޽

	TRIG1 = DD1_AD_TRIG_TIME;			// ADCضڼ޽
										// PWMٽo͌ォ212nsecADݸފJn
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void InitInt(void)
// 			Ȃ
// ߂l		Ȃ
// Tv			荞݊֌Wݒ

void InitInt(void)
{
// IFS0 ڼ޽(荞׸)

	IFS0bits.T1IF = 0;					// T1荞׸ނԂĂ

// IFS6 ڼ޽(荞׸)

	IFS6bits.ADCP0IF = 0;				// AD荞׸ނԂĂ
	IFS6bits.ADCP1IF = 0;

// IEC0 ڼ޽(荞݋)

	IEC0bits.T1IE = ENABLE;				// T1荞݋

// IEC6 ڼ޽(荞݋)

	IEC6bits.ADCP0IE = ENABLE;			// AD荞݋
	IEC6bits.ADCP1IE = ENABLE;

// IPC0 ڼ޽(荞ݗD揇)

	IPC0bits.T1IP = 5;					// T1荞ݗD揇ʂ5ɐݒ

// IPC27 ڼ޽i荞ݗD揇)

	IPC27bits.ADCP0IP = 4;				// AD荞ݗD揇ʂ4ɐݒ
	IPC27bits.ADCP1IP = 6;
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void InitLED1CtrlVariable(void)
// 			Ȃ
// ߂l		Ȃ
// Tv			LEDKvȕϐɏlݒ肷

void InitLED1CtrlVariable(void)
{
	shLED1SetDuty = 1;					// LED ONԂ̍ŏl
	shcLED1On = 1;						// LED ON
	shcLED1Off = LED1_PERIOD - 1;		// LED OFF
	shLED1CtrlFlags.fLEDOn = 0;			// LED ON׸
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void Sw1OnOffCheck(void)
// 			Ȃ
// ߂l		Ȃ
// Tv			Sw1ON-OFFԂ

void Sw1OnOffCheck(void)
{
	if (SW1 == LOW){						// SW1߰LOW(SW1ON)
		if (!shSwFlags.fSw1){				// ONm
			if (!(--bycSw1)){				// 莞Ԍp
				shSwFlags.fSw1 = ON;		// SW1ON׸޾
				bycSw1 = TD10MSPER1MS;		// l
			}
		}
		else
			bycSw1 = TD10MSPER1MS;
	}
	else{									// SW1߰HIGH(SW1OFF)
		if (shSwFlags.fSw1){				// OFFm
			if (!(--bycSw1)){
				shSwFlags.fSw1 = OFF;		// SW1ON׸޸
				shSwFlags.fSw1OnOff = 1;	// ėꂽ
				bycSw1 = TD10MSPER1MS;
			}
		}
		else
			bycSw1 = TD10MSPER1MS;
	}
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void DcDc1ModeChange(void)
// 			Ȃ
// ߂l		Ȃ
// Tv			DcDc1̉^]ԂύX

void DcDc1ModeChange(void)
{
	if (shSwFlags.fSw1OnOff){				// SW1ėꂽ
		if (!shSwFlags.fSw1OnHold){			// SW1Onێ׸
			shSwFlags.fSw1OnHold = 1;		// SW1ONێ׸޾
			shDcDc1Mode = CTRL_MODE;		// ӰނɈڍs
		}
		else{								// SW1ONێ׸
			shSwFlags.fSw1OnHold = 0;		// SW1ONێ׸޸
			shDcDc1Mode = STOP_MODE;		// ~ӰނɈڍs
		}
		shSwFlags.fSw1OnOff = 0;
	}
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void DcDc1ModeCtrl(void)
// 			Ȃ
// ߂l		Ȃ
// Tv			DcDc1^]ԂɉĐ䂷

void DcDc1ModeCtrl(void)
{
	if (shDcDc1Mode == STOP_MODE){			// ~Ӱ
		PTCONbits.PTEN = 0;					// PWM~
		STBY = HIGH;						// ޲
		shDcDc1CtrlFlags.fControl = 0;		// ֎~
		shDcDc1RefVolt = 0;					// d
		shDcDc1RefCurr = 0;					// d
		nDcDc1VoltCtrlVal = 0;				// o͓dʸ
		nDcDc1CurrCtrlVal = 0;				// o͓dʸ
	}
	else if (shDcDc1Mode == CTRL_MODE){		// Ӱ
		PTCONbits.PTEN = 1;					// PWM
		STBY = LOW;							// ޲
		shDcDc1RefVolt = DD1_OPEN_VOLT;		// o͊Jd
		shDcDc1CtrlFlags.fControl = 1;		// 䋖
	}
}


///////////////////////////////////////////////////////////////////////////////
//	֐		void __attribute__((__interrupt__, no_auto_psv)) _T1Interrupt(void)
//			Ȃ
//	߂l		Ȃ
//	Tv		TM1荞݊֐
//				100usecɊ荞݂𔭐A100usec,1msec,10msec,100msecݸ
//				𔭐B

void __attribute__ ((__interrupt__, no_auto_psv)) _T1Interrupt(void)
{
	IFS0bits.T1IF = 0;					// Clear Timer1 Interrupt Flag Status bit 

	shTM1Flags.f100us = 1;					// 100usec׸޾
	shcTM100us++;							// 100usecı
	if (shcTM100us == 10){					// 1msec
		shTM1Flags.f1ms = 1;				// 1msec׸޾
		shcTM100us = 0;						// 100usec
		shcTM1ms++;							// 1msecı
		if (shcTM1ms == 10){				// 10msec
			shTM1Flags.f10ms = 1;			// 10msec׸޾
			shcTM1ms = 0;					// 1msec
			shcTM10ms++;					// 10msecı
			if (shcTM10ms == 10){			// 100msec
				shTM1Flags.f100ms = 1;		// 100msec׸޾
				shcTM10ms = 0;				// 10msec
				shcTM100ms++;				// 100msecı
				if (shcTM100ms == 10){		// 1sec
					shTM1Flags.f1s = 1;		// 1sec׸޾
					shcTM100ms = 0;			// 100msec
				}
			}
		}
	}
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void __attribute__((__interrupt__, no_auto_psv)) _ADCP0Interrupt(void)
// 			Ȃ
// ߂l		Ȃ
// Tv			AN0,AN1ADϊ荞݊֐
//				o͐ݒdяo͐ݒd̎擾

void __attribute__((__interrupt__, no_auto_psv)) _ADCP0Interrupt(void)
{
	IFS6bits.ADCP0IF = 0;						// 荞׸޸

	if (shcRV1Cnt < RV1_CNT_MAX){				// RV1
		nsRV1Sum += ADCBUF0;					// RV1̒lZ
		shcRV1Cnt++;							// Z
	}

	if (shcRV2Cnt < RV2_CNT_MAX){				// RV2
		nsRV2Sum += ADCBUF1;					// RV2̒lZ
		shcRV2Cnt++;							// Z
	}
	else{										// ıߊ
		shRV1Val = nsRV1Sum >> 7;				// RV1ݒl
		shRV2Val = nsRV2Sum >> 11;				// RV2ݒl
		nsRV1Sum = 0;							// Zl
		nsRV2Sum = 0;
		shcRV1Cnt = 0;							// Z񐔸
		shcRV2Cnt = 0;
		shRVFlags.fRVChanged = 1;				// ϒRύX׸
	}

	ADSTATbits.P0RDY = 0;						// ADϊ׸
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void SetCurrDutyRef(void)
// 			Ȃ
// ߂l		Ȃ
// Tv			ϒRldƎ䗦ɐݒ肷

void SetCurrDutyRef(void)
{
	if (shRVFlags.fRVChanged){					// ϒRύX׸
		if (shDcDc1Mode == CTRL_MODE){			// Ӱ
			shDcDc1SetCurr = shRV1Val;			// dɐݒ
			shLED1SetDuty = shRV2Val;			// 䗦ɐݒ
			if (!shLED1SetDuty){
				shLED1SetDuty = 1;
			}
		}
		shRVFlags.fRVChanged = 0;
	}
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void LED1OnOffCtrl(void)
// 			Ȃ
// ߂l		Ȃ
// Tv			LEDON-OFF𐧌䂷
// 				ۯ100usecgp6.4msecƂ

void LED1OnOffCtrl(void)
{
	if (shLED1CtrlFlags.fLEDOn){						// LEDON
		if (!(--shcLED1On)){							// ѱ
			shcLED1Off = LED1_PERIOD - shLED1SetDuty;	// OFFԐݒ
			shDcDc1RefCurr = LED1_OFF_CURR;				// LEDOFF
			shLED1CtrlFlags.fLEDOn = 0;					// LED ON׸޸
		}
	}
	else{												// LEDOFF
		if (!(--shcLED1Off)){							// ѱ
			shcLED1On = shLED1SetDuty;					// ONԐݒ
			shDcDc1RefCurr = shDcDc1SetCurr;			// d̊lݒ
			shLED1CtrlFlags.fLEDOn = 1;					// LED ON׸޾
		}
	}
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void __attribute__((__interrupt__, no_auto_psv)) _ADCP1Interrupt(void)
// 			Ȃ
// ߂l		Ȃ
// Tv			AN2,AN3ADϊ荞݊֐
//				o͓dEo͓d̂̒ddZ

void __attribute__((__interrupt__, no_auto_psv)) _ADCP1Interrupt(void)
{
	long ctrlval;								// 
	int er;										// 덷d
	unsigned pm1, pm2;							// Z

	IFS6bits.ADCP1IF = 0;						// 荞׸޸

	if (shDcDc1CtrlFlags.fControl){				// 䋖

// d

		er = shDcDc1RefVolt - ADCBUF2;			// 덷d

		ctrlval = nDcDc1VoltCtrlVal						// O񐧌
				+ (long)er * DD1_VOLT_K0				// 덷d * K0
				+ (long)shDcDc1VoltE1 * DD1_VOLT_K1;	// O덷d * K1
		if (ctrlval > DD1_VOLT_CTL_MAX){				// ް۰
			ctrlval = DD1_VOLT_CTL_MAX;
		}
		else if (ctrlval < DD1_VOLT_CTL_MIN){			// ް۰
			ctrlval = DD1_VOLT_CTL_MIN;
		}

		nDcDc1VoltCtrlVal = ctrlval;			// ʂۑ
		shDcDc1VoltE1 = er;						// 덷ۑ
		pm1 = ctrlval >> 7;						// dZʂ𓾂

// d

		er = shDcDc1RefCurr - ADCBUF3;			// 덷d

		ctrlval = nDcDc1CurrCtrlVal						// O񐧌
				+ (long)er * DD1_CURR_K0				// 덷d * K0
				+ (long)shDcDc1CurrE1 * DD1_CURR_K1;	// O덷d * K1
		if (ctrlval > DD1_CURR_CTL_MAX){				// ް۰
			ctrlval = DD1_CURR_CTL_MAX;
		}
		else if (ctrlval < DD1_CURR_CTL_MIN){			// ް۰
			ctrlval = DD1_CURR_CTL_MIN;
		}

		nDcDc1CurrCtrlVal = ctrlval;			// ʂۑ
		shDcDc1CurrE1 = er;						// 덷ۑ
		pm2 = ctrlval >> 7;						// dZʂ𓾂

// dƓd̑I

		if (pm1 < pm2){								// d
			PDC1 = pm1;								// PWMݒ
		}
		else{										// d
			PDC1 = pm2;
		}
	}
	else{										// ֎~
		PDC1 = DD1_PWM_MIN;						// ŏٽ
	}

	ADSTATbits.P1RDY = 0;						// ADϊ׸
}


