
///////////////////////////////////////////////////////////////////////////////
//	̧ٖ		DcDc1PowMonitor.c
//	CPU			dsPIC33FJ16GS502
//	e		DCDCް1̒dEdLCD֏o͓dEd
//				\ƋUARTɂPCɑM۸
//	ddl				DC24V
//				io͓d	DC12V
//				io͓d	1.5A
//				ݸގg	300kHz
//	@\		SWONƐݒd܂ŗオ
//				o͓dRV10-DC14V͈̔͂Őݒł
//				o͓dRV20-DC1.5A͈̔͂Őݒł
//				o͓dƏo͓d1secLCD\
//				o͓dƏo͓d1minRS232CʐMɂPCɑM


#include		"p33FJ16GS502.h"
#include		"DcDc1PowMonitor.h"


// ޲ ̨ڰ ڼ޽ ݒϸ

_FOSCSEL(FNOSC_FRC)							// RCUI
_FOSC(FCKSM_CSECMD & OSCIOFNC_ON)			// gύXƎg֎~
_FWDT(FWDTEN_OFF)							// ܫޯ ϋ֎~
_FPOR(FPWRT_PWR128)							// ܰؾĎ128msec
_FICD(ICS_PGD1 & JTAGEN_OFF)				// ʐM@̐ݒ


///////////////////////////////////////////////////////////////////////////////
// Ҳ݊֐		int main(void)
// 			Ȃ
// ߂l		int

int main(void)
{
// 

	InitCLK();								// ۯ̏
	InitIO();								// IO߰Ă̏
	InitTM();								// TM1,2̏
	InitADC();								// ADC̏
	InitPWM1();								// PWM1̏
	InitUart();								// UART̏
	InitInt();								// 荞݊֌W

	T1CONbits.TON = 1;						// TM1n
	T2CONbits.TON = 1;						// TM2n
	ADCONbits.ADON = 1;						// ADϊJn

	InitLCD();								// LCD̏
	shDcDc1Mode = STOP_MODE;				// ^]Ԃ~Ӱނɐݒ
	LCDTitleDisp();							// ٕ\

// ٰ

	while(1){
		SetVoltCurrRef();					// ϒRldEdɐݒ
		DcDc1VoltDisp(1);					// LDC1sڂɏo͓d\
		DcDc1CurrDisp(2);					// LCD2sڂɏo͓d\

		if (shTM1Flags.f1ms){				// 1msecۯ
			Sw1OnOffCheck();				// Sw1ON-OFFԂ
			shTM1Flags.f1ms = 0;
		}

		if (shTM1Flags.f10ms){				// 10msecۯ
			SumDcDc1();						// o͓d,d,d͂̉Z
			LED ^= ON;						// LED10msecON-OFF
			shTM1Flags.f10ms = 0;
		}

		if (shTM1Flags.f1s){				// 1secۯ
			DcDc1CreateDispData();			// LCDɕ\镶\z
			if (shDcDc1Mode == STOP_MODE){	// ~Ӱނ̂Ƃ
				LCDTitleDisp();				// ٕ\
			}
			shCnt++;
			if (shCnt == TD1MPER1S){				// 1min
				shCnt = 0;
				if (shUartFlags.fEnableSend){
					DcDc1CreateTransData();			// PCɑM邽߂̓dEdް\z
					Transmit();						// MJn
				}
			}
			shTM1Flags.f1s = 0;
		}

		DcDc1ModeChange();					// DcDc1̉^]ԂύX
		DcDc1ModeCtrl();					// DcDc1^]ԂɉĐ
	}
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void InitCLK(void)
// 			Ȃ
// ߂l		Ȃ
// e			ۯ֌Wݒ
// 				̊֐̓eϲߎЂ̻۸т̂܂܎gpĂ

void InitCLK(void)
{
	PLLFBD = 41;						// PLL̕ PLLFBD+2=43
	CLKDIVbits.PLLPOST = 0;				// N1 = 2
	CLKDIVbits.PLLPRE = 0;				// N2 = 2

	__builtin_write_OSCCONH(0x01);		// RCUPLLɐݒ
	__builtin_write_OSCCONL(0x01);  	// gύX

	OSCTUNbits.TUN = 1;					// g␳

	while(OSCCONbits.COSC != 0b001);	// PLLɂȂ܂ő҂
	while(OSCCONbits.LOCK != 1);		// PLLۯ܂ő҂

	ACLKCONbits.FRCSEL = 1;				// ⏕UPLLɐݒ
	ACLKCONbits.SELACLK = 1;			// ADCPWM̸ۯpƂĂ̔UI
	ACLKCONbits.APSTSCLR = 7;			// ⏕UH̕1ɐݒ
	ACLKCONbits.ENAPLL = 1;				// PLL

	while(ACLKCONbits.APLLCK != 1);		// PLLۯ܂ő҂
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void InitIO(void)
// 			Ȃ
// ߂l		Ȃ
// e			IO

void InitIO(void)
{
// TRISAڼ޽
	TRISAbits.TRISA3  = OUT;			// DD Con STBY

// TRISBڼ޽
	TRISBbits.TRISB1  = OUT;			// LCD DB4
	TRISBbits.TRISB2  = OUT;			// LCD DB5
	TRISBbits.TRISB3  = OUT;			// LCD DB6
	TRISBbits.TRISB4  = OUT;			// LCD DB7
	TRISBbits.TRISB5  = OUT;			// LED
	TRISBbits.TRISB8  = IN;				// SW1
	TRISBbits.TRISB11 = OUT;			// LCD E
	TRISBbits.TRISB12 = OUT;			// LCD RS
	TRISBbits.TRISB14 = IN;				// SW3(UART)
	TRISBbits.TRISB15 = OUT;			// SW2(UART)

// LATAڼ޽
	LATAbits.LATA3  = HIGH;				// DD Con STBY OFF

// LATBڼ޽
	LATBbits.LATB1  = LOW;
	LATBbits.LATB2  = LOW;
	LATBbits.LATB3  = LOW;
	LATBbits.LATB4  = LOW;
	LATBbits.LATB5  = HIGHOFF;			// LED OFF
	LATBbits.LATB8  = LOW;				// SW1
	LATBbits.LATB11 = LOW;
	LATBbits.LATB12 = LOW;
	LATBbits.LATB14 = LOW;				// SW3(UART)
	LATBbits.LATB15 = LOW;				// SW2(UART)
}


///////////////////////////////////////////////////////////////////////////////
//	֐		void InitTM(void)
//			Ȃ
//	߂l		Ȃ
//	e		TM1,2ۯƂĎgpł悤ɏݒ肷

void InitTM(void)
{
// Timer1
	TMR1 = 0;							//  TM1ڼ޽

// PR1
	PR1 = TM1_CNT;						// lݒ
	
// T1CON
	T1CONbits.TON   = 0;				// ϒ~ォn
	T1CONbits.TCKPS = 0;				// ؽגl 1:1
	T1CONbits.TCS   = 0;				// ۯI

// Timer2
	TMR2 = 0;							//  TM2ڼ޽

// PR2
	PR2 = TM2_CNT;						// lݒ
	
// T2CON
	T2CONbits.TON   = 0;				// ϒ~ォn
	T2CONbits.TCKPS = 0;				// ؽגl 1:1
	T2CONbits.TCS   = 0;				// ۯI
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void InitADC(void)
// 			Ȃ
// ߂l		Ȃ
// e			AN0-AN3gpł悤ADC̏

void InitADC(void)
{
// ADCON ڼ޽

	ADCONbits.ADCS = 3;					// ADC̸ۯ1/4ݒ
	ADCONbits.ADON = 0;					// ADϊ~Cォ狖

// ADSTAT ڼ޽

	ADSTAT = 0;							// ԂĂ

// ADPCFG ڼ޽

	ADPCFGbits.PCFG0 = 0;				// AN0(RV1)ADϊ߰Ăɐݒ
	ADPCFGbits.PCFG1 = 0;				// AN1(RV2)ADϊ߰Ăɐݒ
	ADPCFGbits.PCFG2 = 0;				// AN2(DcDc1o͓d)ADϊ߰Ăɐݒ
	ADPCFGbits.PCFG3 = 0;				// AN3(DcDc1o͓d)ADω߰Ăɐݒ

// ADCPC0 ڼ޽

	ADCPC0bits.IRQEN0 = 1;				// AN0,AN1߱ADϊ荞݋
	ADCPC0bits.IRQEN1 = 1;				// AN2,AN3߱ADϊ荞݋
	ADCPC0bits.TRGSRC0 = 0x1F;			// TM2AN0,AN1߱ADωض޿ɐݒ
	ADCPC0bits.TRGSRC1 = 0x04;			// PWM1AN2,AN3߱ADϊض޿ɐݒ
}


/////////////////////////////////////////////////////////////////////////////////
// ֐		void InitPWM1(void)
// 			Ȃ
// ߂l		Ȃ
// e			PWM1̏

void InitPWM1(void)
{
// PTCON ڼ޽

	PTCONbits.PTEN = 0;					// PWM~Cォ狖
										// n܂ł͒~

// PTPER ڼ޽(PWM ڼ޽)

	PTPER = PWM_PERIOD;					// PWM 7.37*2*32*2=944MHz
										// 944MHz/300kHz=3146

// PWMCON1 ڼ޽

	PWMCON1bits.IUE = 1;				// PWMl̑XV
	PWMCON1bits.DTC = 2;				// ޯюgpȂ

// TRIGCON1

	TRGCON1bits.TRGDIV = 0x2;			// 3񖈂ADϊ

// IOCON1 ڼ޽

	IOCON1bits.PENH = 1;				// PWM1HPWMo͂ɐݒ

// PDC1 ڼ޽

	PDC1 = DD1_PWM_MIN;					// ŏlݒ肵Ă

// TRIG1 ڼ޽

	TRIG1 = DD1_AD_TRIG_TIME;			// ADCضڼ޽
										// PWMٽo͌ォ212nsecADݸފJn
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void InitUart(void)
// 			Ȃ
// ߂l		Ȃ
// e			UART̏ݒs

void InitUart(void)
{
// PRINR18

	RPINR18bits.U1RXR = 6;				// PR6UART1RXϯ

// RPR7

	RPOR3bits.RP7R = 0b000011;			// PR7UART1TXϯ

// U1BRG

	U1BRG = BAUD_9600;					// 9600ްڰĂɐݒ

// U1MODE

	U1MODEbits.UARTEN = 0;				// UART1֎~ォ狖
	U1MODEbits.UEN = 0x00;				// U1TX,U1RX݂̂ݎgp
	U1MODEbits.LPBACK = 0;				// ٰޯ֎~
	U1MODEbits.ABAUD = 0;				// ްڰđ֎~
	U1MODEbits.URXINV = 0;				// ُԂłU1RX1
	U1MODEbits.BRGH = 0;				// ߰
	U1MODEbits.PDSEL = 0x01;			// 8ޯް,è
	U1MODEbits.STSEL = 0;				// 1įޯ

// U1STA

	U1STAbits.UTXISEL1 = 0;				// 
	U1STAbits.UTXISEL0 = 1;				// 
	U1STAbits.UTXINV = 0;				// ُԂłU1TX0
	U1STAbits.UTXEN = 0;				// M֎~ォ狖
	U1STAbits.URXISEL = 0x00;			// MƂ荞
	U1STAbits.ADDEN = 0;				// ڽo֎~

	U1MODEbits.UARTEN = 1;				// UART1(UARTEN)
	U1STAbits.UTXEN = 1;				// UAER1M
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void InitInt(void)
// 			Ȃ
// ߂l		Ȃ
// e			荞݊֌Wݒ

void InitInt(void)
{
// IFS0 ڼ޽(荞׸)

	IFS0bits.T1IF = 0;					// T1荞׸ނԂĂ
	IFS0bits.U1TXIF = 0;				// UART1M荞׸

// IFS6 ڼ޽(荞׸)

	IFS6bits.ADCP0IF = 0;				// AD荞׸ނԂĂ
	IFS6bits.ADCP1IF = 0;

// IEC0 ڼ޽(荞݋)

	IEC0bits.U1TXIE = ENABLE;			// UART1M荞݋
	IEC0bits.T1IE = ENABLE;				// T1荞݋

// IEC6 ڼ޽(荞݋)

	IEC6bits.ADCP0IE = ENABLE;			// AD荞݋
	IEC6bits.ADCP1IE = ENABLE;

// IPC0 ڼ޽(荞ݗD揇)

	IPC0bits.T1IP = 5;					// T1荞ݗD揇ʂ5ɐݒ

// IPC2

	IPC3bits.U1TXIP = 5;				// UART1M荞݂̗D揇ʂ5ɐݒ

// IPC27 ڼ޽i荞ݗD揇)

	IPC27bits.ADCP0IP = 4;				// AD荞ݗD揇ʂ4ɐݒ
	IPC27bits.ADCP1IP = 6;
}


///////////////////////////////////////////////////////////////////////////////
//	֐		void InitLCD(void)
//			Ȃ
//	߂l		Ȃ
//	e		LCD̏s

void InitLCD(void)
{
	WriteWait(15000);						// ݑ҂(15msec)
	LCD4bitCmdWrite(LCD_INIT_CMD_0);		// LCD0(0011)
	WriteWait(4100);
	LCD4bitCmdWrite(LCD_INIT_CMD_0);		// LCD0(0011)
	WriteWait(100);
	LCD4bitCmdWrite(LCD_INIT_CMD_0);		// LCD0(0011)
	LCD4bitCmdWrite(LCD_4BIT_SET_CMD);		// 4rbgްݒ(0010)
	LCD8bitCmdWrite(LCD_FUNC_SET_CMD);		// LCḐݸݐݒ(00101000)
	LCD8bitCmdWrite(LCD_DISP_OFF_CMD);		// LCD\̺(00001000)
	LCD8bitCmdWrite(LCD_CLEAR_CMD);			// LCDԺ(00000001)
	WriteWait(2160);
	LCD8bitCmdWrite(LCD_ENT_MODE_SET_CMD);	// LCDӰ޾ĺ(00000110)
	LCD8bitCmdWrite(LCD_DISP_ON_CMD);		// LCD\ݺ(00001111)
}


///////////////////////////////////////////////////////////////////////////////
//	֐		void WriteWait(unsigned int wt)
//			unsigned int wt
//	߂l		Ȃ
// e			wtmsec҂

void WriteWait(unsigned int wt)
{
	unsigned int t1;
	t1 = wt*8;
	while(--t1){
		Nop();
	}
}


///////////////////////////////////////////////////////////////////////////////
//	֐		void LCDBaseWrite(unsigned char data)
//			unsigned char data;
//	߂l		Ȃ
//	e		ނ܂ް(ݎ40usec)

void LCDBaseWrite(unsigned char data)
{
	unsigned int tm, i = 0;

	LCD_E = HIGH;							// EHIGH(14usec)
	data &= 0x0F;							// 4ޯ
	data <<= 1;								// 1ޯčּ
	tm = PORTB;								// ߰B̎擾
	tm &= 0xFFE1;							// LED߰Ă
	tm |= (unsigned int)data;				// LED߰Ăްݒ
	LATB = tm;								// ׯBްݒ
	while(i < 100){							// EH24usec
		i++;
	}
	LCD_E = LOW;							// ELOW(38usec)
	i = 0;
	while(i < 300){
		i++;
	}
}

///////////////////////////////////////////////////////////////////////////////
//	֐		void LCD4bitCmdWrite(unsigned char cmd)
//			char cmd	8ޯĺ
//	߂l		Ȃ
//	e		4ޯĺނLCDɏ

void LCD4bitCmdWrite(unsigned char cmd)
{
	LCD_RS = LOW;
	LCDBaseWrite(cmd);						// 4ޯĺނ̏
}


///////////////////////////////////////////////////////////////////////////////
//	֐		void LCD8bitCmdWrite(unsigned char cmd)
//			unsigned int cmd	16ޯĺ
//	߂l		Ȃ
//	e		8ޯĺނLCDɏ

void LCD8bitCmdWrite(unsigned char cmd)
{
	unsigned char tm;

	LCD_RS = LOW;							// RSݽ׸݂ɐݒ
	tm = cmd;								// Mނ4ޯļ
	tm >>= 4;
	LCDBaseWrite(tm);						// 4ޯĂ̏
	LCDBaseWrite(cmd);						// 4ޯĂ̏
}


///////////////////////////////////////////////////////////////////////////////
//	֐		void LCDAddressSet(unsigned int address)
//			unsigned int address	16ޯLCD DD RAMڽ
//	߂l		Ȃ
//	e		LCDް]ڽĂ

void LCDAddressSet(unsigned char address)
{
	unsigned char cmd;

	LCD_RS = LOW;
	cmd = 0x80;								// DD RAMڽݒ
	cmd += address;							// ݒڽ
	LCD8bitCmdWrite(cmd);					// ނ
}


///////////////////////////////////////////////////////////////////////////////
//	֐		void LCD8bitDataWrite(unsigned int data)
//			unsigned int data	16ޯđMް
//	߂l		Ȃ
//	e		8ޯްLCDɏ

void LCD8bitDataWrite(unsigned char data)
{
	unsigned char tm;

	LCD_RS = HIGH;							// RSްMɐݒ
	tm = data;
	tm >>= 4;								// Mް4ޯļ
	LCDBaseWrite(tm);						// 4ޯĂ̏
	LCDBaseWrite(data);						// 4ޯĂ̏
}


///////////////////////////////////////////////////////////////////////////////
//	֐		void DispLCD(unsigned char* pt, unsigned int len)
//			unsigned char data	\ް߲
//				unsigned int len	\
//	߂l		Ȃ
//	e		ptŎ񂩂len̕LCDɕ\

void DispLCD(char* pt, unsigned char len)
{
	char dispdata;
	unsigned char i;

	for(i = 0; i < len; i++){				// 0len-1܂
		dispdata = *(pt + i);				// pt
		LCD8bitDataWrite(dispdata);			// \
	}
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void LCDTitleDisp(void)
// 			Ȃ
// ߂l		Ȃ
// e			ق\

void LCDTitleDisp(void)
{
	LCDAddressSet(0x00);					// 1sڽıڽ
	DispLCD("Welcome to our  ", 16);		// 1sڕ\
	LCDAddressSet(0x40);					// 2sڽıڽ
	DispLCD("     Laboratory", 15);			// 2sڕ\
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void Sw1OnOffCheck(void)
// 			Ȃ
// ߂l		Ȃ
// e			Sw1ON-OFFԂ

void Sw1OnOffCheck(void)
{
	if (SW1 == LOW){						// SW1߰LOW(SW1ON)
		if (!shSwFlags.fSw1){				// ONm
			if (!(--bycSw1)){				// 莞Ԍp
				shSwFlags.fSw1 = ON;		// SW1ON׸޾
				bycSw1 = TD10MSPER1MS;		// l
			}
		}
		else
			bycSw1 = TD10MSPER1MS;
	}
	else{									// SW1߰HIGH(SW1OFF)
		if (shSwFlags.fSw1){				// OFFm
			if (!(--bycSw1)){
				shSwFlags.fSw1 = OFF;		// SW1ON׸޸
				shSwFlags.fSw1OnOff = 1;	// *V0.2 ėꂽ
				bycSw1 = TD10MSPER1MS;
			}
		}
		else
			bycSw1 = TD10MSPER1MS;
	}
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void DcDc1ModeChange(void)
// 			Ȃ
// ߂l		Ȃ
// e			SW1̏ԂɉDcDc1̉^]ԂύX

void DcDc1ModeChange(void)
{
	if (shSwFlags.fSw1OnOff){				// SW1ėꂽ
		if (!shSwFlags.fSw1OnHold){			// SW1Onێ׸
			shSwFlags.fSw1OnHold = 1;		// SW1ONێ׸޾
			shDcDc1Mode = CTRL_MODE;		// ӰނɈڍs
		}
		else{								// SW1ONێ׸
			shSwFlags.fSw1OnHold = 0;		// SW1ONێ׸޸
			shDcDc1Mode = STOP_MODE;		// ~ӰނɈڍs
		}
		shSwFlags.fSw1OnOff = 0;
	}
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void DcDc1ModeCtrl(void)
// 			Ȃ
// ߂l		Ȃ
// e			DcDc1^]ԂɉĐ䂷

void DcDc1ModeCtrl(void)
{
	if (shDcDc1Mode == STOP_MODE){			// ~Ӱ
		PTCONbits.PTEN = 0;					// PWM~
		STBY = HIGH;						// ޲
		shDcDc1CtrlFlags.fControl = 0;		// ֎~
		shUartFlags.fEnableSend = 0;		// ްM֎~
		shDcDc1RefVolt = 0;					// d
		shDcDc1RefCurr = 0;					// d
		nDcDc1VoltCtrlVal = 0;				// o͓dʸ
		nDcDc1CurrCtrlVal = 0;				// o͓dʸ
	}
	else if (shDcDc1Mode == CTRL_MODE){		// Ӱ
		PTCONbits.PTEN = 1;					// PWM
		STBY = LOW;							// ޲
		shDcDc1CtrlFlags.fControl = 1;		// 䋖
		shUartFlags.fEnableSend = 1;		// M
	}
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void SumDcDc1(void)
// 			Ȃ
// ߂l		Ȃ
// e			DcDc1̏o͓dAo͓dAo͓d͂ԊuŉZ


void SumDcDc1(void)
{
	unsigned long tm;

	nsDcDc1Volt += ADCBUF2;					// o͓dlZ
	nsDcDc1Curr += ADCBUF3;					// o͓dlZ
	tm = (unsigned long)ADCBUF2 * ADCBUF3;	// o͓d͂vZ
	nsDcDc1Pow += tm >> 8;					// o͓d͂kĉZ
	shcDcDc1++;								// Z𑝉
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void CulcuAveDcDc1(void)
// 			Ȃ
// ߂l		Ȃ
// e			DcDc1̏o͓dAo͓dAo͓d͂̕ϒlvZ
//				ZlƉZԂɔ

void CalcuAveDcDc1(void)
{
	shaveDcDc1Volt = nsDcDc1Volt / shcDcDc1;	// ϒľvZ
	shaveDcDc1Curr = nsDcDc1Curr / shcDcDc1;
	shaveDcDc1Pow = nsDcDc1Pow / shcDcDc1;
	nsDcDc1Volt = 0;							// Zlƶ̸
	nsDcDc1Curr = 0;
	nsDcDc1Pow = 0;
	shcDcDc1 = 0;
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void CreateDcDc1DispData(void)
// 			Ȃ
// ߂l		Ȃ
// e			LCDɕ\o͓dƓd̕\z

void DcDc1CreateDispData(void)
{
	if (shDcDc1Mode == CTRL_MODE){							// Ӱ
		CalcuAveDcDc1();									// ϒlvZ

		shDcDc1RealVolt = 
			CalcuRealVal(shaveDcDc1Volt, DD1_REALVOLT_COEF);	// o͓dlɕϊ
		ChangeValToStr(cDcDc1RealVolt, shDcDc1RealVolt);	// o͓d𕶎ɕϊ
		InsertPoint(cDcDc1RealVolt, 2);						// o͓dɏ_ǉxx.xx
		if (cDcDc1RealVolt[0] == '0'){						// ŏ̕0̂Ƃ
			cDcDc1RealVolt[0] = ' ';						// 󔒂ɂ
		}
		shDcDc1DispFlags.fVolt = 1;							// LCDɏo͓d̕\

		shDcDc1RealCurr =
			CalcuRealVal(shaveDcDc1Curr, DD1_REALCURR_COEF);	// o͓dlɕϊ
		ChangeValToStr(cDcDc1RealCurr, shDcDc1RealCurr);	// o͓d𕶎ɕϊ
		InsertPoint(cDcDc1RealCurr, 1);						// o͓dɏ_ǉxx.xx
		shDcDc1DispFlags.fCurr = 1;							// LCDo͓d̕\

		shDcDc1RealPow =
			CalcuRealVal(shaveDcDc1Pow, DD1_REALPOW_COEF);		// o͓d͂lɕϊ
		ChangeValToStr(cDcDc1RealPow, shDcDc1RealPow);		// o͓d͂𕶎ɕϊ
		InsertPoint(cDcDc1RealPow, 2);						// o͓d͂ɏ_ǉxx.xx
		if (cDcDc1RealPow[0] == '0'){						// ŏ̕0̂Ƃ
			cDcDc1RealPow[0] = ' ';							// 󔒂ɂ
		}
		shDcDc1DispFlags.fPow = 1;							// LCDɏo͓d͂̕\
	}
}


///////////////////////////////////////////////////////////////////////////////
// ֐		unsigned int CulcRealVal(unsigned int val, unsigned int coef)
// 			unsigned int val	lɕωl
//				unsigned int coef	l邽߂̌W
// ߂l		unsigned int 		l
// e			DSPްlɕϊ

unsigned int CalcuRealVal(unsigned int val, unsigned int coef)
{
	unsigned long tm;

	tm = (unsigned long)val * coef;				// W|
	tm >>= 12;									// 12ޯļ
	return (unsigned int)tm;					// hex̎l𓾂
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void ChangeStrToVal(char* pt, unsigned int val)
// 			char* pt			\iϊ
// 				unsigned int val	ϊl
// e			l𕶎ɕϊ
//				l̑傫Ɋ֌WȂ4(4)ɕϊ(0000-9999)
//				0̏ꍇ͋󔒂ɂȂ炸"0"ɂȂ

void ChangeValToStr(char* pt, unsigned int val)
{
	unsigned int tm;

	tm = val / 1000;					// 1000̌
	*(pt+0) = tm + 0x30;				// 1000̌ɕϊ
	val -= tm * 1000;					// 1000̌
	tm = val / 100;						// 100̌
	*(pt+1) = tm + 0x30;				// 100̌𕶎ɕϊ
	val -= tm * 100;					// 100̌
	tm = val / 10;						// 10̌
	*(pt+2) = tm + 0x30;				// 10̌𕶎ɕϊ
	val -= tm * 10;						// 10̌
	*(pt+3) = val + 0x30;				// 1̌𕶎ɕϊ
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void InsertPoint(char* pt, unsigned int place)
// 			char* pt			(4ɌŒ)
// 				unsigned int place	ŏ߲̕Ă̈ʒu(0ް)
// ߂l		Ȃ
// e			ŏ̕placeŎ߲̌(.)}
//				Aplace1-3̒l
//				ŏ̑̕OƍŌ̌̕ɂ߲Ă͑}Ȃ

void InsertPoint(char* pt, unsigned int place)
{
	unsigned int i;

	if (place == 0 || place == 4){		// 04̂Ƃ͏I
		return;
	}

	for (i = 4; i > place; i--){		// placeȍ~1炷
		*(pt + i) = *(pt + i - 1);
	}
	*(pt + place) ='.';					// "."}
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void DcDc1VoltDisp(unsigned int line)
// 			unsigned int line	\s
// ߂l		Ȃ
// e			LCDlinesɏo͓d\

void DcDc1VoltDisp(unsigned int line)
{
	unsigned char tm;

	if (shDcDc1DispFlags.fVolt){			// o͓d\
		if (line == 2){						// line=2
			tm = 0x40;
		}
		else{								// line=1
			tm = 0x00;
		}
		LCDAddressSet(tm);					// 0ɱڽݒ
		DispLCD("Out.Volt.=", 10);			// Out.Volt.=ƕ\
		DispLCD(cDcDc1RealVolt, 5);			// o͓dxx.xxƕ\
		DispLCD("V", 1);					// Vƕ\
		shDcDc1DispFlags.fVolt = 0;			// ׸޸
	}
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void DcDc1CurrDisp(unsigned int line)
// 			unsigned int line	\s
// ߂l		Ȃ
// e			LCDlinesɏo͓d\

void DcDc1CurrDisp(unsigned int line)
{
	unsigned char tm;

	if (shDcDc1DispFlags.fCurr){			// o͓d\
		if (line == 2){						// line=2
			tm = 0x40;
		}
		else{								// line=1
			tm = 0x00;
		}
		LCDAddressSet(tm);					// 0ɱڽݒ
		DispLCD("Out.Curr.=", 10);			// Out.Curr.=ƕ\
		DispLCD(cDcDc1RealCurr, 4);			// o͓dx.xxƕ\
		DispLCD("A", 1);					// Aƕ\
		shDcDc1DispFlags.fCurr = 0;			// ׸޸
	}
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void DcDc1CreateTransData(void)
// 			Ȃ
// ߂l		Ȃ
// e			dEdްPCɑM邽߂̕\z

void DcDc1CreateTransData(void)
{
	unsigned int i;

	for (i = 0; i < 5; i++){					// dް
		cTransBuff[i] = cDcDc1RealVolt[i];
	}

	cTransBuff[5] = HT;							// 

	for (i = 0; i < 4; i++){					// dް
		cTransBuff[i+6] = cDcDc1RealCurr[i];
	}
	cTransBuff[10] = CR;						// LbW

	shTransLen = 11;							// M

	shUartFlags.fTransmit = 1;					// M׸޾
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void Transmit(void)
// 			Ȃ
// ߂l		Ȃ
// e			MJn

void Transmit(void)
{
	if (shUartFlags.fTransmit){					// Mv׸
		U1TXREG = cTransBuff[0];				// MJn
		shcTransmit = 1;						// M𑝉
		shUartFlags.fTransmit = 0;				// Mv׸޸
		shUartFlags.fTransIn = 1;				// M׸޾
	}
}


///////////////////////////////////////////////////////////////////////////////
//	֐		void __attribute__((__interrupt__, no_auto_psv)) _T1Interrupt(void)
//			Ȃ
//	߂l		Ȃ
//	e		TM1荞݊֐
//				100usecɊ荞݂𔭐A100usec,1msec,10msec,100msecݸ
//				𔭐B

void __attribute__ ((__interrupt__, no_auto_psv)) _T1Interrupt(void)
{
	IFS0bits.T1IF = 0;					// Clear Timer1 Interrupt Flag Status bit 

	shTM1Flags.f100us = 1;					// 100usec׸޾
	shcTM100us++;							// 100usecı
	if (shcTM100us == 10){					// 1msec
		shTM1Flags.f1ms = 1;				// 1msec׸޾
		shcTM100us = 0;						// 100usec
		shcTM1ms++;							// 1msecı
		if (shcTM1ms == 10){				// 10msec
			shTM1Flags.f10ms = 1;			// 10msec׸޾
			shcTM1ms = 0;					// 1msec
			shcTM10ms++;					// 10msecı
			if (shcTM10ms == 10){			// 100msec
				shTM1Flags.f100ms = 1;		// 100msec׸޾
				shcTM10ms = 0;				// 10msec
				shcTM100ms++;				// 100msecı
				if (shcTM100ms == 10){		// 1sec
					shTM1Flags.f1s = 1;		// 1sec׸޾
					shcTM100ms = 0;			// 100msec
				}
			}
		}
	}
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void __attribute__((__interrupt__, no_auto_psv)) _ADCP0Interrupt(void)
// 			Ȃ
// ߂l		Ȃ
// e			AN0,AN1ADϊ荞݊֐
//				o͐ݒdяo͐ݒd̎擾
//				̏ADCP0荞݂ōs

void __attribute__((__interrupt__, no_auto_psv)) _ADCP0Interrupt(void)
{
	IFS6bits.ADCP0IF = 0;						// 荞׸޸

	if (shcRV2Cnt < RV2_CNT_MAX){				// RV2
		nsRV2Sum += ADCBUF1;					// RV2̒lZ
		shcRV2Cnt++;							// Z
	}

	if (shcRV1Cnt < RV1_CNT_MAX){				// RV1
		nsRV1Sum += ADCBUF0;					// RV1̒lZ
		shcRV1Cnt++;							// Z
	}
	else{										// ıߊ
		shRV1Val = nsRV1Sum >> 7;				// RV1ݒl
		shRV2Val = nsRV2Sum >> 7;				// RV2ݒl
		nsRV1Sum = 0;							// Zl
		nsRV2Sum = 0;
		shcRV1Cnt = 0;							// Z񐔸
		shcRV2Cnt = 0;
		shRVFlags.fRVChanged = 1;				// ϒRύX׸
	}

	ADSTATbits.P0RDY = 0;						// ADϊ׸
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void SetVoltCurrRef(void)
// 			Ȃ
// ߂l		Ȃ
// e			ϒRldƊdɐݒ肷

void SetVoltCurrRef(void)
{
	if (shRVFlags.fRVChanged){					// ϒRύX׸
		if (shDcDc1Mode == CTRL_MODE){			// Ӱ
			shDcDc1RefVolt = shRV1Val;			// dɐݒ
			if (shRV2Val > DD1_REF_CURR){		// ődɐ
				shDcDc1RefCurr = DD1_REF_CURR;
			}
			else{
				shDcDc1RefCurr = shRV2Val;		// dɐݒ
			}	
		}
		shRVFlags.fRVChanged = 0;
	}
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void __attribute__((__interrupt__, no_auto_psv)) _ADCP1Interrupt(void)
// 			Ȃ
// ߂l		Ȃ
// e			AN2,AN3ADϊ荞݊֐
//				o͂̒dƒdPIZ

void __attribute__((__interrupt__, no_auto_psv)) _ADCP1Interrupt(void)
{
	long ctrlval;								// 
	int er;										// 덷d
	unsigned pm1, pm2;							// Z

	IFS6bits.ADCP1IF = 0;						// 荞׸޸

	if (shDcDc1CtrlFlags.fControl){				// 䋖

// d

		er = shDcDc1RefVolt - ADCBUF2;			// 덷d

		ctrlval = nDcDc1VoltCtrlVal						// O񐧌
				+ (long)er * DD1_VOLT_K0				// 덷d * K0
				+ (long)shDcDc1VoltE1 * DD1_VOLT_K1;	// O덷d * K1
		if (ctrlval > DD1_VOLT_CTL_MAX){				// ް۰
			ctrlval = DD1_VOLT_CTL_MAX;
		}
		else if (ctrlval < DD1_VOLT_CTL_MIN){			// ް۰
			ctrlval = DD1_VOLT_CTL_MIN;
		}

		nDcDc1VoltCtrlVal = ctrlval;			// ʂۑ
		shDcDc1VoltE1 = er;						// 덷ۑ
		pm1 = ctrlval >> 7;						// dZʂ𓾂

// d

		er = shDcDc1RefCurr - ADCBUF3;			// 덷d

		ctrlval = nDcDc1CurrCtrlVal						// O񐧌
				+ (long)er * DD1_CURR_K0				// 덷d * K0
				+ (long)shDcDc1CurrE1 * DD1_CURR_K1;	// O덷d * K1
		if (ctrlval > DD1_CURR_CTL_MAX){				// ް۰
			ctrlval = DD1_CURR_CTL_MAX;
		}
		else if (ctrlval < DD1_CURR_CTL_MIN){			// ް۰
			ctrlval = DD1_CURR_CTL_MIN;
		}

		nDcDc1CurrCtrlVal = ctrlval;			// ʂۑ
		shDcDc1CurrE1 = er;						// 덷ۑ
		pm2 = ctrlval >> 7;						// dZʂ𓾂

// dƓd̑I

		if (pm1 < pm2){								// d
			PDC1 = pm1;								// PWMݒ
		}
		else{										// d
			PDC1 = pm2;
		}
	}
	else{										// ֎~
		PDC1 = DD1_PWM_MIN;						// ŏٽ
	}

	ADSTATbits.P1RDY = 0;						// ADϊ׸
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void __attribute__((__interrupt__, no_auto_osv)) _U1TXInterrupt(void)
// 			Ȃ
// ߂l		Ȃ
// e			UARTM荞
//				1MɊ荞݂𔭐

void __attribute__ ((__interrupt__, no_auto_psv)) _U1TXInterrupt(void)
{
	IFS0bits.U1TXIF  = 0;						// 荞׸ނ̸

	if (shUartFlags.fTransIn){					// M̂Ƃ
		if (shcTransmit < shTransLen){			// M̂Ƃ
			U1TXREG = cTransBuff[shcTransmit];	// 𑗐M
			shcTransmit++;						// M𑝉
		}
		else{
			shUartFlags.fTransIn = 0;			// M׸޸ԂI
		}
	}
}


