/******************************************************************************
	x̎ ȂŉMĉx𑪒			2010 Masaji Kasahara
******************************************************************************/

#include <p33Fxxxx.h>	// vWFNgŐݒ肵foCXpwb_ǂݍ܂
#include <math.h>
#include <uart.h>
#include <ctype.h>
#include "my.h"

_FOSCSEL(FNOSC_FRC);	// NFRCB(NPLLɐ؂ւ)
_FOSC(POSCMD_NONE & OSCIOFNC_ON & FCKSM_CSECMD & IOL1WAY_OFF);
_FWDT(FWDTEN_OFF);		// EHb`hbO^C}֎~

#define PERIOD 1575		// }X^[^Cx[X XCb`Og600kHz

// MENU_VALmenu.cōĂ郁j[[`gۂ̕ϐ̌^(int^)
MENU_VAL duty=60;		// f[eBݒl(l60%)
#define MENU_NO	1
struct menu_dat menu_dats[MENU_NO] = {
	// type,        str, *value, max,min,row,column,curpos
	{ INT_MENU,    "100",  &duty, 100,  0,  0,    5,    0  }
};


int main( void )
{
	int wait1sec;
	init();							// 
	lcd_init();						//LCD
	LCD_LOCATE( 0, 0 );	lcd_str( "DUTY= 60%" );		// j[\
	LCD_LOCATE( 1, 0 );	lcd_str( "TEMP=20.0C" );

	while(1){
		menu( menu_dats, MENU_NO );	// [U[C^tF[X(10ms|)
		
		if( wait1sec++ > 100 ){		// 1bɈA
			wait1sec = 0;
			thermo_measure();		// x֐sB
		}
	}
}


void thermo_measure( void )
{
	float thermistor_ohm, x, thermistor_deg;
	char buf[10];

	thermistor_ohm = 8.2E3 * 1023 / ADCBUF1 - (8.2E3 + 220);	// T[~X^̒Rl
	x = log10( thermistor_ohm );
	thermistor_deg  =  -1.7386*x*x*x + 31.966*x*x - 233.33*x + 558.11;	// 

	PDC2 = (long)PERIOD * duty / 100;	// PWM2H̃f[eBݒ

	itoa_f( "  00", duty, buf );		// duty̐l񌅂̐()ɕϊ
	putsUART1( (unsigned int *)buf );	// buf[] ̕RS-232Cɏo
	putsUART1( (unsigned int *)", " );	// J}RS-232Cɏo

	itoa_f( "00.0", thermistor_deg * 10, buf );	// x_ȉ1̕
	LCD_LOCATE( 1, 5 );							// LCD1s5ڂ(0IW)
	lcd_str( buf );								// x\
	putsUART1( (unsigned int *)buf );			// RS-232Cɂo
	putsUART1( (unsigned int *)"\r\n" );		// RS-232Cɉso
}


void init( void )
{
	unsigned int baudvalue, U1MODEvalue, U1STAvalue;
	SET_CPU_IPL( 7 );				// 荞݋֎~
	Nop();
	NJW4800_STBY = 1;
	TRISA = 0x0007;					// 1̃rbg͓̓s
	TRISB = 0xC741;					// 1̃rbg͓̓s

	// NbNFRC+PLLɐ؂ւ39.6MIPSɂ
	// (IV[^{}jAp42-23,42-2)
	PLLFBD = 41;					// PLL M = 43
	CLKDIVbits.PLLPOST = 0;			// PLL N1 = 2
	CLKDIVbits.PLLPRE = 0;			// PLL N2 = 2
	__builtin_write_OSCCONH(0x01);	// FRC+PLLɐ؂ւJn
	__builtin_write_OSCCONL(0x01);
	while(OSCCONbits.COSC != 0b001);// NbN؂ւ҂
	while(OSCCONbits.LOCK != 1);	// PLLbN҂

	// ADC/PWMW[p⏕NbN(ACLK)FRC+⏕PLL(16{)117.9MHzɂ
	ACLKCONbits.FRCSEL = 1;			// ⏕PLLFRC
	ACLKCONbits.SELACLK = 1;
	ACLKCONbits.APSTSCLR = 7;
	ACLKCONbits.ENAPLL = 1;			// ⏕PLLCl[u
	while(ACLKCONbits.APLLCK != 1);	// ⏕PLLbN҂
	
	// PWMݒ({\tgłPWM1o͎͂gȂ̂ŁAPWM1pݒ̓RgAEg)
//	PWMCON1bits.ITB = 0;		// }X^[^Cx[X[h
	PWMCON2bits.ITB = 0;
//	PWMCON1bits.CAM = 0;		// GbWAC[h
	PWMCON2bits.CAM = 0;
//	IOCON1bits.PMOD = 0;		// o̓[h
	IOCON2bits.PMOD = 0;
	PTCONbits.PTEN  = 1;		// PWMW[L
//	PWMCON1bits.DTC = 2;		// fbh^C@\
	PWMCON2bits.DTC = 2;
	PTPER = PERIOD;				// }X^[^Cx[XXCb`Og600kHz
	IOCON1bits.PENH = 1;		// PWMW[PWM1H/PWM2Hs𐧌
	IOCON2bits.PENH = 1;
	
	// A/DRo[^ TvO()
	ADCONbits.EIE = 0;			// ADCyAϊIĂ犄荞
	ADCONbits.FORM = 0;			// A/Dʂ0:unsigned int/1:Œ菬
	ADCONbits.SLOWCLK = 1;		// ACLK(117.92M)gp(Gb^FK1ɂ邱)
	ADCONbits.ADCS = 4;			// ADNbNFADC/5 = 23.584MHz
	TRIG1bits.TRGCMP = 0;		// PWMWFl[^1APWMʑ0ŃgKo
	TRGCON1bits.TRGDIV = 13;	// PWMpX141TvO(42.9ksps)
	_TRGSRC0 = 4;				// PWMWFl[^11gKADCyA0(AN0,AN1)ϊ
//	_TRGSRC1 = 4;				// PWMWFl[^11gKADCyA1(AN2,AN3)ϊ
//	_TRGSRC2 = 4;				// PWMWFl[^11gKADCyA2(AN4,AN5)ϊ
	ADPCFG = 0;					// SAiO̓sADCƂĎgpAiO[h
	ADCONbits.ADON = 1;			// ADCW[Cl[u

	NJW4800_STBY = 0;			// NJW4800o͊Jn

	// UART1
	RPOR3bits.RP7R = 3;			// RP7U1TXo
	CloseUART1();
	baudvalue = 85;				// 39.6MIPS/115200bps/4-1 (BRGH=1)
	U1MODEvalue =   UART_EN & UART_IDLE_CON & UART_IrDA_DISABLE
				& UART_MODE_FLOW & UART_UEN_00		// CTS, RTSsgp
				& UART_DIS_WAKE & UART_DIS_LOOPBACK
				& UART_EN_ABAUD
				& UART_UXRX_IDLE_ONE				// Mɐ:U1RXAChԂu1vƂ
				& UART_BRGH_FOUR					// BRG[h BRGH=1
				& UART_NO_PAR_8BIT & UART_1STOPBIT;	// peBAf[^8bitAXgbv1bit
	U1STAvalue  =   UART_INT_TX_BUF_EMPTY			// (荞݂͎gȂ̂ŋCɂȂ)
				& UART_IrDA_POL_INV_ZERO			// Mɐ:U1TXAChԂu1vƂ
				& UART_SYNC_BREAK_DISABLED			// u[NI
				& UART_TX_ENABLE					// TxsL
				& UART_INT_RX_3_4_FUL				// (荞݂͎gȂ̂ŋCɂȂ)
				& UART_ADR_DETECT_DIS & UART_RX_OVERRUN_CLEAR;
	OpenUART1(U1MODEvalue, U1STAvalue, baudvalue);

	RCON=0;		// sӂɃZbgƂɃfobKRCON𒲂ׂƗv
}
