///////////////////////////////////////////////
//  t\퐧䃉Cu
//  ֐͈ȉ
//    lcd_init()    ------- 
//    lcd_cmd(cmd)  ------- R}ho
//    lcd_data(chr) ------- P\o
//    lcd_clear()   ------- S
//    lcd_str(char *str)--- \
//////////////////////////////////////////////

#include <p33Fxxxx.h>	// vWFNgŐݒ肵foCXpwb_ǂݍ܂
#include <timer.h>

const int lcd_adrbase[4] = { 0x80, 0xC0, 0x94, 0xD4 };	// 4sLCD̍sAhX

//////// usecfBC֐
void delay(unsigned usec)
{
	//T2 16bits counter
	T2CON = 0;					// ^C}~
	_T2IF = 0;					// tONA
	OpenTimer2( T2_ON & T2_GATE_OFF & T2_PS_1_64 & T2_32BIT_MODE_OFF
			 & T2_SOURCE_INT,  (usec/2 + usec/8 + 1) );
	while( !_T2IF )
		;
}

//////// f[^o̓Tu֐
#define RS		_LATB12
#define STB		_LATB11
void lcd_out(int code, int flag)
{
	LATB = (LATB & 0xE1) | 
		 	((code & 0xF0)>>3);	//o̓f[^ʂSrbg
	if (flag == 0)				//\f[^R}h
		RS = 1;					//\f[^̏ꍇRS=1
	else
		RS = 0;					//R}hf[^̏ꍇRS=0
	Nop();	Nop();				//NOP@XL[m	60nsȏ
	STB = 1;					//STB ON
	Nop();	Nop();	Nop();		//pXm450nsecȏ
	Nop();	Nop();	Nop();	Nop();	Nop();	Nop();	Nop();
	Nop();	Nop();	Nop();	Nop();	Nop();	Nop();	Nop();
	STB = 0;					//STB OFF
	Nop();	Nop();	Nop();		//pXm450nsecȏ
	Nop();	Nop();	Nop();	Nop();	Nop();	Nop();	Nop();
	Nop();	Nop();	Nop();	Nop();	Nop();	Nop();	Nop();
}

//////// P\֐
void lcd_data(int asci)
{
	lcd_out(asci, 0);			//ʂSrbgo
	lcd_out(asci<<4, 0);		//ʂSrbgo
	delay(50);					//50sec҂
}

/////// R}ho͊֐
void lcd_cmd(int cmd)
{
	lcd_out(cmd, 1);			//ʂSrbgo
	lcd_out(cmd<<4, 1);			//ʂSrbgo
	if((cmd == 0x01) || (cmd == 0x02))
		delay(2000);			//2msec҂
	else
		delay(50);				//50usec҂
}	

/////// S֐
void lcd_clear(void)
{
	lcd_cmd(0x01);				//R}ho
}

/////// o͊֐
void lcd_str(char *str)
{
	while(*str != 0x00)			//̏I蔻
	{
		lcd_data(*str);			//Po
		str++;					//|C^{P
	}
}

/////// ֐
void lcd_init(void)
{
	STB = 0;
	delay(15000);				//15msec
	lcd_out(0x30, 1);			//8bit mode set
	delay(5000);
	lcd_out(0x30, 1);			//8bit mode set
	delay(5000);/////1000
	lcd_out(0x30, 1);			//8bit mode set
	delay(2000);///1000
	lcd_out(0x20, 1);			//4bit mode set
	delay(1000);
	lcd_cmd(0x2E);				//DL=0 4bit mode
	lcd_cmd(0x08);				//display off C=D=B=0
	lcd_cmd(0x01);				//all clear
	delay(5000);
	lcd_cmd(0x06);				//entry I/D=1 S=0
	lcd_cmd(0x0E);				//display on D=C=1 B=0
	delay(1600);				//1.6msec
}
