
///////////////////////////////////////////////////////////////////////////////
//	̧ٖ		DcDc1LEDCtrl.h
//	CPU			dsPIC33FJ16GS502
//	e		3FLED̋PxɎgp萔,ϐ,׸ނ`


///////////////////////////////////////////////////////////////////////////////
// 

#define		OUT					0			// o
#define		IN					1			// 

#define		ON					1
#define		OFF					0

#define		HIGH				1
#define		LOW					0

#define		HIGHOFF				1
#define		LOWON				0

#define		ENABLE				1			// 
#define		DISABLE				0			// ֎~

#define		STOP_MODE			0			// ~Ӱ
#define		CTRL_MODE			1			// Ӱ


///////////////////////////////////////////////////////////////////////////////
// IO߰Ă̖

#define		STBY		LATAbits.LATA3		// DD Con STBY

#define		SW1			PORTBbits.RB8		// SW1
#define		SW2			PORTBbits.RB15		// SW2
#define		SW3			PORTBbits.RB14		// SW3

#define		LED			LATBbits.LATB5		// LED

#define		LCD_E		LATBbits.LATB11		// LCD E
#define		LCD_RS		LATBbits.LATB12		// LCD RS


///////////////////////////////////////////////////////////////////////////////
// ϊ֌W

// ϐݒ

#define		TM1_CNT				3963		// 100usec
											// 7.3728*43/4/2=39.63MHz/10kHz=3963
#define		TM2_CNT				3169		// 80usec
											// 7.37*43/4/2=39.61MHz/12.5kHz=3169

// ԌW

#define		TD10MSPER1MS		10			// 10msec(1msecۯ)


///////////////////////////////////////////////////////////////////////////////
// PWM֌W萔

// PWM

#define		PWM_PERIOD			3146		// 7.3728*32*4=943.7184MHz
											// 943.7184MHz/300kHz=3146

// DcDC1PWMݒ

#define		DD1_PWM_MIN			8
#define		DD1_AD_TRIG_TIME	778			// AN2,AN3ΰޒx
											// 3300/4/1.06=778nsec


///////////////////////////////////////////////////////////////////////////////
// DcDc1ްdEd֌W萔
// Ă̐lƈvȂ͎̂ɍ킹Ă邽

// dd
	
#define		DD1_REF_VOLT		843			// 12Vd
											// 12/12.7k*2.7k/3.195V*1023=817
#define		DD1_REF_CURR		981			// 1.5Ad
											// 1.5*0.1*20/3.195V*1023=961

// W

// DcDc1d

#define		DD1_VOLT_K0			1024		// K0	P=2, I=0.5msec
#define		DD1_VOLT_K1			-1012		// K1

// DcDc1d

#define		DD1_CURR_K0			264			// K0	P=0.5, I=0.3msec
#define		DD1_CURR_K1			-247		// K1


// Я

// DcDc1d

#define		DD1_VOLT_CTL_MAX	322150		// ʂ̍ől 0.8*3146*128
#define		DD1_VOLT_CTL_MIN	1024		// ʂ̍ŏl 8*128=1024

// DcDc1d

#define		DD1_CURR_CTL_MAX	342284		// 0.85*3146*128
#define		DD1_CURR_CTL_MIN	1024		// 8*128=1024


///////////////////////////////////////////////////////////////////////////////
// ϒRl̎擾֌W萔

// ADϊ

#define		RV1_CNT_MAX			85			// RV1̍ő̂Ƃo͓d1Aɐݒ
#define		RV2_CNT_MAX			128			// RV2ő̂Ƃ䗦100%ɐݒ


///////////////////////////////////////////////////////////////////////////////
// LEDPx֌W̒萔

#define	DD1_OPEN_VOLT			843			// Jd12Vɐݒ

#define LED1_PERIOD				64			// 6.4msec(100usecۯ)

#define LED1_OFF_CURR			0			// 0A


///////////////////////////////////////////////////////////////////////////////
// ۰ϊ֌W

// ϐ

unsigned int shcTM100us __attribute__((__near__));	// 100usec ۯ
unsigned int shcTM1ms __attribute__((__near__));	// 1msec ۯ
unsigned int shcTM10ms __attribute__((__near__));	// 10msec ۯ
unsigned int shcTM100ms __attribute__((__near__));	// 100msec ۯ

// ׸

typedef struct tagTM1FLAGS{
	unsigned int f100us:	1;		// 100usec ۯ׸
	unsigned int f1ms:		1;		// 1mssec ۯ׸
	unsigned int f10ms:		1;		// 10msec ۯ׸
	unsigned int f100ms:	1;		// 100msec ۯ׸
	unsigned int f1s:		1;		// *V0.2 1sec ۯ׸
}TM1FLAGS;

TM1FLAGS shTM1Flags __attribute__((__near__));			// ۯ׸


//////////////////////////////////////////////////////////////////////////////
// ֌W

// ϐ

unsigned char bycSw1;				// SW1 ON-OFF足

// ׸

typedef struct tagSW{
	unsigned int fSw1:			1;			// SW1׸	1:ON, 0:OFF
	unsigned int fSw1OnOff:		1;			// SW1ėꂽ
	unsigned int fSw1OnHold:	1;			// SW1ONێꂽ
}SW_FLAGS;

SW_FLAGS shSwFlags __attribute__((__near__));	// ׸


///////////////////////////////////////////////////////////////////////////////
// DcDc1dEd֌W

// ϐ

unsigned int shDcDc1Mode __attribute__((__near__));		// ^]Ӱ

unsigned int shDcDc1RefVolt __attribute__((__near__));	// d
unsigned int shDcDc1RefCurr __attribute__((__near__));	// d

long nDcDc1VoltCtrlVal __attribute__((__near__));		// Od
int shDcDc1VoltE1 __attribute__((__near__));			// Od덷

long nDcDc1CurrCtrlVal __attribute__((__near__));		// Od
int shDcDc1CurrE1 __attribute__((__near__));			// Od덷


// ׸

typedef struct tagCTRLFLAGS{
	unsigned int fControl:			1;					// 䋖
}CTRL_FLAGS;

CTRL_FLAGS shDcDc1CtrlFlags __attribute__((__near__));	// DcDc1׸


///////////////////////////////////////////////////////////////////////////////
// ϒRADϊl擾֌W

// ϐ

unsigned int shRV1Val __attribute__((__near__));		// RV1̒l
unsigned long nsRV1Sum __attribute__((__near__));		// RV1̉Zl
unsigned int shcRV1Cnt __attribute__((__near__));		// RV1̉Z

unsigned int shRV2Val __attribute__((__near__));		// RV2̒l
unsigned long nsRV2Sum __attribute__((__near__));		// RV2̉Zl
unsigned int shcRV2Cnt __attribute__((__near__));		// RV2̉Z

// ׸

typedef struct tagRVFLAGS{
	unsigned int fRVChanged:		1;		// ϒRύXꂽ
}RV_FLAGS;

RV_FLAGS shRVFlags __attribute__((__near__));		// ϒR׸


///////////////////////////////////////////////////////////////////////////////
// LED̋Px֌W

// ϐ

unsigned int shLED1SetDuty __attribute__((__near__));	// LEDON̎䗦
unsigned int shDcDc1SetCurr __attribute__((__near__));	// LEDݒd

unsigned int shcLED1On __attribute__((__near__));		// ON
unsigned int shcLED1Off __attribute__((__near__));		// OFF

// ׸

typedef struct tagLEDFLAGS{
	unsigned int fLEDOn:		1;			// LEDON׸
}LEDCTRLFLAGS;

LEDCTRLFLAGS shLED1CtrlFlags __attribute__((__near__));


///////////////////////////////////////////////////////////////////////////////
//	֐錾

// ֐

void InitCLK(void);						// ۯ̏
void InitIO(void);						// IO߰Ă̏
void InitTM(void);						// TM1,2̏
void InitADC(void);						// ADC̏
void InitPWM1(void);					// PWM1̏
void InitInt(void);						// 荞݊֌W
void InitLED1CtrlVariable(void);		// LEDɕKvȕϐ̏

// SW1֐

void Sw1OnOffCheck(void);				// Sw1ON-OFFԂ

// DcDc1ް֐

void DcDc1ModeChange(void);				// DcDc1̉^]ԂύX
void DcDc1ModeCtrl(void);				// DcDc1^]ԂɉĐ

// ϒRl̎擾֐

void SetCurrDutyRef(void);				// ϒRldƎ䗦ɐݒ

// LED̋Px֐

void LED1OnOffCtrl(void);				// LEDON-OFF

// 荞݊֐

void __attribute__((__interrupt__, no_auto_psv)) _ADCP0Interrupt(void);	// ADω߱0荞
void __attribute__((__interrupt__, no_auto_psv)) _ADCP1Interrupt(void);	// ADϊ߱1荞


