
///////////////////////////////////////////////////////////////////////////////
//	̧ٖ		BLMotorCtrl.c
//	CPU			dsPIC33FJ16GS502
//	e		3ɂDC׼ڽӰ̉]s
//	ddl				DC24V
//				io͓d	AC7.5V
//				io͓d	2A
//				ݸގg	300kHz
//	@\		SWONƐݒd܂ŗオ
//				o͓dRV10-AC7.5V͈̔͂Őݒł
//				o͎gRV250-1000Hz͈̔͂Őݒł


#include		"p33FJ16GS502.h"
#include		"BLMotorCtrl.h"


// ޲ ̨ڰ ڼ޽ ݒϸ

_FOSCSEL(FNOSC_FRC)							// RCUI
_FOSC(FCKSM_CSECMD & OSCIOFNC_ON)			// gύXƎg֎~
_FWDT(FWDTEN_OFF)							// ܫޯ ϋ֎~
_FPOR(FPWRT_PWR128)							// ܰؾĎ128msec׳  ؾċ֎~
_FICD(ICS_PGD1 & JTAGEN_OFF)				// ʐM@̐ݒ


///////////////////////////////////////////////////////////////////////////////
// Ҳ݊֐		int main(void)
// 			Ȃ
// ߂l		int
// Tv			main۸

int main(void)
{
// 

	InitCLK();							// ۯ̏
	InitIO();							// IO߰Ă̏
	InitTM();							// TM1-3̏
	InitADC();							// ADC̏
	InitPWM();							// PWM1,2̏
	InitInt();							// 荞݊֌W

	shTM3Cnt = TM3_CNT;

	T1CONbits.TON = 1;					// TM1n
	T2CONbits.TON = 1;					// TM2n
	T3CONbits.TON = 1;					// TM3n
	ADCONbits.ADON = 1;					// ADϊJn

	while(1){
		CalcuMotorPeriod();				// gύX

		if (shTM1Flags.f1ms){			// 1msecۯ
			Sw1OnOffCheck();			// Sw1ON-OFFԂ
			shTM1Flags.f1ms = 0;
		}

		if (shTM1Flags.f10ms){			// 10msecۯ
			LED ^= ON;					// LED10msecON-OFF
			shTM1Flags.f10ms = 0;
		}

		DcDc12ModeChange();				// DcDc12̉^]ԂύX
		DcDc12ModeCtrl();				// DcDc12^]ԂɉĐ
	}
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void InitCLK(void)
// 			Ȃ
// ߂l		Ȃ
// e			ۯ֌Wݒ
// 				̊֐̓eϲߎЂ̻۸т̂܂܎gpĂ

void InitCLK(void)
{
	PLLFBD = 41;						// PLL̕ PLLFBD+2=43
	CLKDIVbits.PLLPOST = 0;				// N1 = 2
	CLKDIVbits.PLLPRE = 0;				// N2 = 2

	__builtin_write_OSCCONH(0x01);		// RCUPLLɐݒ
	__builtin_write_OSCCONL(0x01);  	// gύX

	OSCTUNbits.TUN = 1;					// g␳

	while(OSCCONbits.COSC != 0b001);	// PLLɂȂ܂ő҂
	while(OSCCONbits.LOCK != 1);		// PLLۯ܂ő҂

	ACLKCONbits.FRCSEL = 1;				// ⏕UPLLɐݒ
	ACLKCONbits.SELACLK = 1;			// ADCPWM̸ۯpƂĂ̔UI
	ACLKCONbits.APSTSCLR = 7;			// ⏕UH̕1ɐݒ
	ACLKCONbits.ENAPLL = 1;				// PLL

	while(ACLKCONbits.APLLCK != 1);		// PLLۯ܂ő҂
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void InitIO(void)
// 			Ȃ
// ߂l		Ȃ
// e			IO

void InitIO(void)
{
// TRISAڼ޽
	TRISAbits.TRISA3  = OUT;			// DD Con STBY

// TRISBڼ޽
	TRISBbits.TRISB1  = OUT;			// LCD DB4
	TRISBbits.TRISB2  = OUT;			// LCD DB5
	TRISBbits.TRISB3  = OUT;			// LCD DB6
	TRISBbits.TRISB4  = OUT;			// LCD DB7
	TRISBbits.TRISB5  = OUT;			// LED
	TRISBbits.TRISB8  = IN;				// SW1
	TRISBbits.TRISB11 = OUT;			// LCD E
	TRISBbits.TRISB12 = OUT;			// LCD RS
	TRISBbits.TRISB14 = IN;				// SW3(UART)
	TRISBbits.TRISB15 = OUT;			// SW2(UART)

// LATAڼ޽
	LATAbits.LATA3  = HIGH;				// DD Con STBY OFF

// LATBڼ޽
	LATBbits.LATB1  = LOW;
	LATBbits.LATB2  = LOW;
	LATBbits.LATB3  = LOW;
	LATBbits.LATB4  = LOW;
	LATBbits.LATB5  = HIGHOFF;			// LED OFF
	LATBbits.LATB8  = LOW;				// SW1
	LATBbits.LATB11 = LOW;
	LATBbits.LATB12 = LOW;
	LATBbits.LATB14 = LOW;				// SW3(UART)
	LATBbits.LATB15 = LOW;				// SW2(UART)
}


///////////////////////////////////////////////////////////////////////////////
//	֐		void InitTM(void)
//			Ȃ
//	߂l		Ȃ
//	e		TM1-3ۯƂĎgpł悤ɏݒ肷

void InitTM(void)
{
// Timer1
	TMR1 = 0;							//  TM1ڼ޽

// PR1
	PR1 = TM1_CNT;						// lݒ
	
// T1CON
	T1CONbits.TON   = 0;				// ϒ~ォn
	T1CONbits.TCKPS = 0;				// ؽגl 1:1
	T1CONbits.TCS   = 0;				// ۯI

// Timer2
	TMR2 = 0;							//  TM2ڼ޽

// PR2,3
	PR2 = TM2_CNT;						// lݒ

// T2CON
	T2CONbits.TON   = 0;				// ϒ~ォn
	T2CONbits.TCKPS = 0;				// ؽגl 1:1
	T2CONbits.T32   = 0;				// 16ޯӰ
	T2CONbits.TCS   = 0;				// ۯI

// Timer3
	TMR3 = 0;							//  TM3ڼ޽

// PR3
	PR3 = TM3_CNT;						// 1Hz

// T3CON

	T3CONbits.TON   = 0;				// ϒ~ォn
	T3CONbits.TCKPS = 0;				// ؽגl 1:1
	T3CONbits.TCS   = 0;				// ۯI
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void InitADC(void)
// 			Ȃ
// ߂l		Ȃ
// e			ADC̏

void InitADC(void)
{
// ADCON ڼ޽

	ADCONbits.ADCS = 3;					// ADC̸ۯ1/4ݒ
	ADCONbits.ADON = 0;					// ADϊ~Cォ狖

// ADSTAT ڼ޽

	ADSTAT = 0;							// ԂĂ

// ADPCFG ڼ޽

	ADPCFGbits.PCFG0 = 0;				// AN0(RV1)ADϊ߰Ăɐݒ
	ADPCFGbits.PCFG1 = 0;				// AN1(RV2)ADϊ߰Ăɐݒ

// ADCPC0 ڼ޽

	ADCPC0bits.IRQEN0 = 1;				// AN0,AN1߱ADϊ荞݋
	ADCPC0bits.TRGSRC0 = 0x1F;			// TM2AN0,AN1߱ADωض޿ɐݒ
}


/////////////////////////////////////////////////////////////////////////////////
// ֐		void InitPWM(void)
// 			Ȃ
// ߂l		Ȃ
// e			PWM1̏

void InitPWM(void)
{
// PTCON ڼ޽

	PTCONbits.PTEN = 0;					// PWM~Cォ狖

// PTPER ڼ޽(PWM ڼ޽)

	PTPER = PWM_PERIOD;					// PWM 7.3728*43*2*2=944MHz
										// 944MHz/300kHz=3146

// PWMCON1,2 ڼ޽

	PWMCON1bits.IUE = 1;				// PWMl̑XV
	PWMCON1bits.DTC = 2;				// ޯюgpȂ

	PWMCON2bits.IUE = 1;				// PWMl̑XV
	PWMCON2bits.DTC = 2;				// ޯюgpȂ

// TRIGCON1

	TRGCON1bits.TRGDIV = 0x2;			// 3񖈂ADϊ

// IOCON1,2 ڼ޽

	IOCON1bits.PENH = 1;				// PWM1HPWMo͂ɐݒ
	IOCON2bits.PENH = 1;				// PWM2HPWMo͂ɐݒ

// PDC1 ڼ޽

	PDC1 = DD1_PWM_MIN;					// ŏlݒ肵Ă
	PDC2 = DD2_PWM_MIN;					// ŏlݒ肵Ă
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void InitInt(void)
// 			Ȃ
// ߂l		Ȃ
// e			荞݊֌Wݒ

void InitInt(void)
{
// IFS0 ڼ޽(荞׸)

	IFS0bits.T1IF = 0;					// T1荞׸ނԂĂ
	IFS0bits.T3IF = 0;					// T3荞׸ނԂĂ

// IFS6 ڼ޽(荞׸)

	IFS6bits.ADCP0IF = 0;				// AD荞׸ނԂĂ
	IFS6bits.ADCP1IF = 0;

// IFS7 ڼ޽(荞׸)

	IFS7bits.ADCP2IF = 0;

// IEC0 ڼ޽(荞݋)

	IEC0bits.T1IE = ENABLE;				// T1荞݋
	IEC0bits.T3IE = ENABLE;				// T3荞݋

// IEC6 ڼ޽(荞݋)

	IEC6bits.ADCP0IE = ENABLE;			// AN0,1荞݋

// IPC0,1,2,3 ڼ޽(荞ݗD揇)

	IPC0bits.T1IP = 6;					// T1荞ݗD揇ʂ6ɐݒ
	IPC2bits.T3IP = 5;					// T3荞ݗD揇ʂ5ɐݒ

// IPC27 ڼ޽i荞ݗD揇)

	IPC27bits.ADCP0IP = 6;				// AD荞ݗD揇ʂ4ɐݒ
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void Sw1OnOffCheck(void)
// 			Ȃ
// ߂l		Ȃ
// e			Sw1ON-OFFԂ

void Sw1OnOffCheck(void)
{
	if (SW1 == LOW){						// SW1߰LOW(SW1ON)
		if (!shSwFlags.fSw1){				// ONm
			if (!(--bycSw1)){				// 莞Ԍp
				shSwFlags.fSw1 = ON;		// SW1ON׸޾
				bycSw1 = TD10MSPER1MS;		// l
			}
		}
		else
			bycSw1 = TD10MSPER1MS;
	}
	else{									// SW1߰HIGH(SW1OFF)
		if (shSwFlags.fSw1){				// OFFm
			if (!(--bycSw1)){
				shSwFlags.fSw1 = OFF;		// SW1ON׸޸
				shSwFlags.fSw1OnOff = 1;	// ėꂽ
				bycSw1 = TD10MSPER1MS;
			}
		}
		else
			bycSw1 = TD10MSPER1MS;
	}
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void DcDc12ModeCtrl(void)
// 			Ȃ
// ߂l		Ȃ
// e			DcDc12^]ԂɉĐ䂷

void DcDc12ModeCtrl(void)
{
	if (shDcDc12Mode == STOP_MODE){			// ~Ӱ
		PTCONbits.PTEN = 0;					// PWM~
		STBY = HIGH;						// ޲
	}
	else if (shDcDc12Mode == CTRL_MODE){	// Ӱ
		PTCONbits.PTEN = 1;					// PWM
		STBY = LOW;							// ޲
	}
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void DcDc12ModeChange(void)
// 			Ȃ
// ߂l		Ȃ
// e			DcDc12̉^]ԂύX

void DcDc12ModeChange(void)
{
	if (shSwFlags.fSw1OnOff){				// SW1ėꂽ
		if (!shSwFlags.fSw1OnHold){			// SW1Onێ׸
			shSwFlags.fSw1OnHold = 1;		// SW1ONێ׸޾
			shDcDc12Mode = CTRL_MODE;		// ӰނɈڍs
		}
		else{								// SW1ONێ׸
			shSwFlags.fSw1OnHold = 0;		// SW1ONێ׸޸
			shDcDc12Mode = STOP_MODE;		// ~ӰނɈڍs
		}
		shSwFlags.fSw1OnOff = 0;
	}
}


///////////////////////////////////////////////////////////////////////////////
//	֐		void __attribute__((__interrupt__, no_auto_psv)) _T1Interrupt(void)
//			Ȃ
//	߂l		Ȃ
//	Tv		TM1荞݊֐
//				100usecɊ荞݂𔭐A100usec,1msec,10msec,100msecݸ
//				𔭐B

void __attribute__ ((__interrupt__, no_auto_psv)) _T1Interrupt(void)
{
	IFS0bits.T1IF = 0;					// Clear Timer1 Interrupt Flag Status bit 

	shTM1Flags.f100us = 1;					// 100usec׸޾
	shcTM100us++;							// 100usecı
	if (shcTM100us == 10){					// 1msec
		shTM1Flags.f1ms = 1;				// 1msec׸޾
		shcTM100us = 0;						// 100usec
		shcTM1ms++;							// 1msecı
		if (shcTM1ms == 10){				// 10msec
			shTM1Flags.f10ms = 1;			// 10msec׸޾
			shcTM1ms = 0;					// 1msec
			shcTM10ms++;					// 10msecı
			if (shcTM10ms == 10){			// 100msec
				shTM1Flags.f100ms = 1;		// 100msec׸޾
				shcTM10ms = 0;				// 10msec
				shcTM100ms++;				// 100msecı
				if (shcTM100ms == 10){		// 1sec
					shTM1Flags.f1s = 1;		// 1sec׸޾
					shcTM100ms = 0;			// 100msec
				}
			}
		}
	}
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void __attribute__((__interrupt__, no_auto_psv)) _ADCP0Interrupt(void)
// 			Ȃ
// ߂l		Ȃ
// e			AN0,AN1ADϊ荞݊֐
//				RV1RV2̎擾
//				̏ADCP0荞݂ōs

void __attribute__((__interrupt__, no_auto_psv)) _ADCP0Interrupt(void)
{
	IFS6bits.ADCP0IF = 0;						// 荞׸޸

	if (shcRV2Cnt < RV2_CNT_MAX){				// RV2
		nsRV2Sum += ADCBUF1;					// RV2̒lZ
		shcRV2Cnt++;							// Z
	}

	if (shcRV1Cnt < RV1_CNT_MAX){				// RV1
		nsRV1Sum += ADCBUF0;					// RV1̒lZ
		shcRV1Cnt++;							// Z
	}
	else{										// ıߊ
		shRV1Val = nsRV1Sum >> 7;				// RV1ݒl
		shRV2Val = nsRV2Sum >> 7;				// RV2ݒl
		nsRV1Sum = 0;							// Zl
		nsRV2Sum = 0;
		shcRV1Cnt = 0;							// Z񐔸
		shcRV2Cnt = 0;
		shDcDc12CtrlFlags.fFreqChange = 1;		// gύX׸
	}

	ADSTATbits.P0RDY = 0;						// ADϊ׸
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void __attribute__((__interrupt__, no_auto_psv)) _T3Interrupt(void)
// 			Ȃ
// ߂l		Ȃ
// e			TM3荞݊֐
//			

void __attribute__ ((__interrupt__, no_auto_psv)) _T3Interrupt(void)
{
	int x;
	long y;

	IFS0bits.T3IF = 0;							// 荞׸ނ

	PR3 = shTM3Cnt;								// 3ɶĒlݒ

	shNumSineU++;
	if (shNumSineU == NUM_SINE_MAX){			// U
		shNumSineU = 0;
	}

	shNumSineW = shNumSineU + W_PHASE;			// W(+60)
	if (shNumSineW > NUM_SINE_MAX){
		shNumSineW -= NUM_SINE_MAX;
	}

	y = (long)shSineData[shNumSineU] * shMotorVolt;		// 
	x = y >> 10;
	PDC1 = CENTER + x;							// 1573+/-1024

	y = (long)shSineData[shNumSineW] * shMotorVolt;
	x = y >> 10;
	PDC2 = CENTER + x		;					// 1573+/-1024
}


///////////////////////////////////////////////////////////////////////////////
// ֐		void CalcuMoterFreq(void)
// 			Ȃ
// ߂l		Ȃ
// e			RV2̒lӰ̎ɕϊ
//				Ӱ̎gɔႳēdύX

void CalcuMotorPeriod(void)
{
	unsigned int x;
	unsigned long tm;

	if (shDcDc12CtrlFlags.fFreqChange){

// Ӱg
		tm = (unsigned long)shRV2Val * PWM_MAG;		// PWM_MAG=973
		shMotorFreq = tm >> 10;
		shMotorFreq += 51;
		tm = SYSCLOCK / shMotorFreq;				// 50-1000Hz
		x = tm / NUM_SINE_MAX;						// ް̐ŊZ
		if (x > 2200)
			x = 2200;
		else if (x < 110)
			x = 110;
		shTM3Cnt = x;

// Ӱd
		if (shMotorFreq < MOTOR_FREQ_MIN){			// 300Hzȉ̂Ƃ
			x = MOTOR_VOLT_MIN;						// 0.86Vɐݒ
		}
		else{										// 300Hzȏ̂Ƃ
			x = shMotorFreq;						// Ӱgɔ
		}
		if (x > shRV1Val){							// Ӱd
			x = shRV1Val;							// ϒR̒lɐ
		}
		tm = (unsigned long)x * VOLT_MAG;			// ӰdɊZ
		shMotorVolt = tm >> 10;

		shDcDc12CtrlFlags.fFreqChange = 0;
	}
}


