/******************************************************************************
	M[`
******************************************************************************/

#include <p33Fxxxx.h>	// vWFNgŐݒ肵foCXpwb_ǂݍ܂
#include <math.h>
#include <string.h>
#include <dsp.h>
#include "my.h"


/******************************************************************************
	OCR(IIRtB^)pϐƏ֐
******************************************************************************/
fractional _XDATA(2) GEQCoefs[ 5 * GEQNumSections ] = {	// l̓tbg
//	 b0/2, b1/2, a1/2, b2/2, a2/2
	16384,    0,    0,    0,    0,	// 񎟃tB^1(150Hz)
	16384,    0,    0,    0,    0,	// 񎟃tB^2( 2kHz)
	16384,    0,    0,    0,    0,	// 񎟃tB^3( 6kHz)
	16384,    0,    0,    0,    0	// 񎟃tB^4(20kHz)
};

fractional _YBSS(2) GEQStates1_ch1[GEQNumSections], GEQStates2_ch1[GEQNumSections];
fractional _YBSS(2) GEQStates1_ch2[GEQNumSections], GEQStates2_ch2[GEQNumSections];

IIRTransposedStruct GraphicEqualizer[2] = {	// LR 2ch
	{
		GEQNumSections-1,
		GEQCoefs,
		COEFFS_IN_DATA,		// WGEQCoefsXf[^ɂ邱ƂwB
		GEQStates1_ch1,		// xobt@
		GEQStates2_ch1,
		0					//final shift. negative indicates shift left,
	},
	{
		GEQNumSections-1,
		GEQCoefs,
		COEFFS_IN_DATA,		// WGEQCoefsXf[^ɂ邱ƂwB
		GEQStates1_ch2,		// xobt@
		GEQStates2_ch2,
		0					//final shift. negative indicates shift left,
	}
};

void GEQ_init( void )
{
	IIRTransposedInit(&(GraphicEqualizer[0]));	// LR 2ch
	IIRTransposedInit(&(GraphicEqualizer[1]));
}


/******************************************************************************
	OCRIIRtB^WC[`ŌvZB
	OCR̊egݒlzɓÃAhXgeqŎw肷B
	vZIIRtB^WGEQCoefsɏo͂B
	(vZGEQCoefs͊荞݃[`ŎQƂ)
******************************************************************************/
#define fs			44400	// TvOg [Hz]
#define AMAX		1.45	// g̕`萔AB̍őlEŏl
#define AMIN		0.45
#define IIRNUMCOF	5	// IIRTransposed b0,b1,a1,b2,a2 5̌W^
void calc_geqcoef( MENU_VAL *geq )
{
	const unsigned frqtbl[GEQNumSections] = { 150, 2000, 6000, 20000 }; //Hz
	int f;
	fractional coefbuf[IIRNUMCOF];
	fractional *coef = GEQCoefs;

	for( f=0; f<GEQNumSections; f++ ){
		float wo = 2 * PI * frqtbl[f];
		float p = 4.0*fs*fs + wo*wo;
		float q = 2.0 * fs * wo;
		float A = (*geq++ / 18.0 + 0.5) * (AMAX - AMIN)  +  AMIN;
		float B = AMAX + AMIN - A;
		float k0a = 32768 / 2 / (p + q/A);
		
		coefbuf[0] = k0a * (p + q/B);				// b0/2
		coefbuf[1] = k0a * (2.0*wo*wo - 8.0*fs*fs);	// b1/2
		coefbuf[2] = -coefbuf[1];					// a1/2
		coefbuf[3] = k0a * (p - q/B);				// b2/2
		coefbuf[4] = k0a * (q/A - p);				// a2/2
		
//		DIS_INTERRUPT;	// ZԂmemcpyΊ֎~ȂĂɲނ͖ڗȂ
		memcpy( coef, coefbuf, sizeof(coefbuf) );	// 0.4us(opt1)
//		ENA_INTERRUPT;
		coef += IIRNUMCOF;
	}
}
