
///////////////////////////////////////////////////////////////////////////////
//	̧ٖ			DcDc1PowMon.h
//	CPU				dsPIC33FJ16GS502
//	e			DcDc1PowMon.cŎgp萔,ϐ,׸,֐`


///////////////////////////////////////////////////////////////////////////////
// 

#define		OUT					0			// o
#define		IN					1			// 

#define		ON					1
#define		OFF					0

#define		HIGH				1
#define		LOW					0

#define		HIGHOFF				1
#define		LOWON				0

#define		ENABLE				1			// 
#define		DISABLE				0			// ֎~

#define		STOP_MODE			0			// ~Ӱ
#define		CTRL_MODE			1			// Ӱ


///////////////////////////////////////////////////////////////////////////////
// IO߰Ă̖

#define		STBY		LATAbits.LATA3		// DD Con STBY

#define		SW1			PORTBbits.RB8		// SW1
#define		SW2			PORTBbits.RB15		// SW2
#define		SW3			PORTBbits.RB14		// SW3

#define		LED			LATBbits.LATB5		// LED

#define		LCD_E		LATBbits.LATB11		// LCD E
#define		LCD_RS		LATBbits.LATB12		// LCD RS


///////////////////////////////////////////////////////////////////////////////
// ϊ֌W

// ϐݒ

#define		TM1_CNT				3963		// 100usec
											// 7.3728*43/4/2=39.63MHz/10kHz=3963
#define		TM2_CNT				3169		// 80usec
											// 7.37*43/4/2=39.61MHz/12.5kHz=3169

// ԌW

#define		TD10MSPER1MS		10			// 10msec(1msecۯ)
#define		TD1MPER1S			60			// 1min(1secۯ)


///////////////////////////////////////////////////////////////////////////////
// PWM֌W萔

// PWM

#define		PWM_PERIOD			3146		// 7.3728*32*4=943.7184MHz
											// 943.7184MHz/300kHz=3146

// DcDc1PWMݒ

#define		DD1_PWM_MAX			2517		// 3146*0.8=2517
#define		DD1_PWM_MIN			8
#define		DD1_AD_TRIG_TIME	778			// AN2,AN3ΰޒx
											// 3300/4/1.06=778nsec


///////////////////////////////////////////////////////////////////////////////
// DcDc1ްdEd֌W萔
// Ă̐lƈvȂ͎̂ɍ킹Ă邽

// dd

#define		DD1_REF_VOLT		843			// 12Vd
											// 12/12.7k*2.7k/3.195V*1023=817
#define		DD1_REF_CURR		981			// 1.5Ad
											// 1.5*0.1*20/3.195V*1023=961
// W
// DcDc1d

#define		DD1_VOLT_K0			1024		// K0	P=2, I=0.5msec
#define		DD1_VOLT_K1			-1012		// K1

// DcDc1d

#define		DD1_CURR_K0			264			// K0	P=0.5, I=0.3msec
#define		DD1_CURR_K1			-247		// K1


// Я
// DcDc1d

#define		DD1_VOLT_CTL_MAX	322150		// ʂ̍ől 0.8*3146*128
#define		DD1_VOLT_CTL_MIN	1024		// ʂ̍ŏl 8*128=1024

// DcDc1d

#define		DD1_CURR_CTL_MAX	342284		// 0.85*3146*128
#define		DD1_CURR_CTL_MIN	1024		// 8*128=1024


///////////////////////////////////////////////////////////////////////////////
// ϒRl̎擾֌W萔

// ADϊ

#define		RV1_CNT_MAX		128				// RV1̍ő̂Ƃo͓dDC14Vɐݒ
#define		RV2_CNT_MAX		128				// RV2ő̂Ƃo͓d1.5Aɐݒ


///////////////////////////////////////////////////////////////////////////////
// DSPްlɕϊ֌W萔

#define		DD1_REALVOLT_COEF	5831		// 1200*4096/843=5831(12ޯļ)
#define		DD1_REALCURR_COEF	6100		// 1400*4096/940=6100(12ޯļ)
#define		DD1_REALPOW_COEF	2404		// 1680*4096/3102=2404


///////////////////////////////////////////////////////////////////////////////
// LCD֌W萔

// LCD 
#define		LCD_INIT_CMD_0			0x03		// 00000011 
#define		LCD_4BIT_SET_CMD		0x02		// 00000010 4ޯްݒ
#define		LCD_FUNC_SET_CMD		0x28		// 00101000 ̧ݸݾĺ
#define		LCD_DISP_OFF_CMD		0x08		// 00001000 LCD̺
#define		LCD_CLEAR_CMD			0x01		// 00000001 LCDԺ
#define		LCD_ENT_MODE_SET_CMD	0x06		// 00000110 LCDӰ޾ĺ
#define		LCD_DISP_ON_CMD			0x0F		// 00001111 LCDݺ


///////////////////////////////////////////////////////////////////////////////
// UART֌W

#define		BAUD_2400			1031			// 2400Baud 7.3728*43/4/2=39.629
												// U1BRG=39,629,123/16/2400-1=1031
#define		BAUD_4800			516				// 4800Baud
												// U1BRG=39.629/16/4800-1=516															
#define		BAUD_9600			257				// 9600Baud
												// U1BRB=39,629,123/16/9600-1=257
#define		BAUD_19200			128				// U1BRG=39,629,123/16/19200-1=128


#define		TIME_OUT			TD5SPER10MS		// 5sec
#define		BUFF_SIZE			32				// 32޲

#define		LF					0x0A
#define		CR					0x0D
#define		HT					0x09


///////////////////////////////////////////////////////////////////////////////
// ۰ϊ֌W̕ϐ

// ϐ

unsigned int shcTM100us __attribute__((__near__));	// 100usec ۯ
unsigned int shcTM1ms __attribute__((__near__));	// 1msec ۯ
unsigned int shcTM10ms __attribute__((__near__));	// 10msec ۯ
unsigned int shcTM100ms __attribute__((__near__));	// 100msec ۯ

// ׸

typedef struct tagTM1FLAGS{
	unsigned int f100us:	1;		// 100usec ۯ׸
	unsigned int f1ms:		1;		// 1mssec ۯ׸
	unsigned int f10ms:		1;		// 10msec ۯ׸
	unsigned int f100ms:	1;		// 100msec ۯ׸
	unsigned int f1s:		1;		// 1sec ۯ׸
}TM1FLAGS;

TM1FLAGS shTM1Flags __attribute__((__near__));		// ۯ׸ޒ`


//////////////////////////////////////////////////////////////////////////////
// ֌W̕ϐ

// ϐ

unsigned char bycSw1;				// SW1 ON-OFF足

// ׸

typedef struct tagSW{
	unsigned int fSw1:			1;			// SW1׸	1:ON, 0:OFF
	unsigned int fSw1OnOff:		1;			// SW1ėꂽ
	unsigned int fSw1OnHold:	1;			// SW1ONێꂽ
}SW_FLAGS;

SW_FLAGS shSwFlags __attribute__((__near__));	// ׸


///////////////////////////////////////////////////////////////////////////////
// DcDc1dEd֌W

// ϐ

unsigned int shDcDc1Mode __attribute__((__near__));		// ^]Ӱ

unsigned int shDcDc1RefVolt __attribute__((__near__));	// d
unsigned int shDcDc1RefCurr __attribute__((__near__));	// d

long nDcDc1VoltCtrlVal __attribute__((__near__));		// Od
int shDcDc1VoltE1 __attribute__((__near__));			// Od덷

long nDcDc1CurrCtrlVal __attribute__((__near__));		// Od
int shDcDc1CurrE1 __attribute__((__near__));			// Od덷

// ׸

typedef struct tagCTRLFLAGS{
	unsigned int fControl:			1;					// 䋖
}CTRL_FLAGS;

CTRL_FLAGS shDcDc1CtrlFlags __attribute__((__near__));	// DcDc1׸


///////////////////////////////////////////////////////////////////////////////
// ϒRADϊl擾֌W

// ϐ

unsigned int shRV1Val __attribute__((__near__));		// RV1̒l
unsigned long nsRV1Sum __attribute__((__near__));		// RV1̉Zl
unsigned int shcRV1Cnt __attribute__((__near__));		// RV1̉Z

unsigned int shRV2Val __attribute__((__near__));		// RV2̒l
unsigned long nsRV2Sum __attribute__((__near__));		// RV2̉Zl
unsigned int shcRV2Cnt __attribute__((__near__));		// RV2̉Z

// ׸

typedef struct tagRVFLAGS{
	unsigned int fRVChanged:		1;					// ϒRlύXꂽ
}RV_FLAGS;

RV_FLAGS shRVFlags __attribute__((__near__));		// ϒR׸


///////////////////////////////////////////////////////////////////////////////
// o͓dEo͓d̕ω֌W̕ϐ

unsigned long nsDcDc1Volt __attribute__((__near__));	// o͓d̉Zl
unsigned long nsDcDc1Curr __attribute__((__near__));	// o͓d̉Zl
unsigned long nsDcDc1Pow __attribute__((__near__));		// o͓d͂̉Zl
unsigned int shcDcDc1 __attribute__((__near__));		// Z
unsigned int shaveDcDc1Volt __attribute__((__near__));	// Ϗo͓d
unsigned int shaveDcDc1Curr __attribute__((__near__));	// Ϗo͓d
unsigned int shaveDcDc1Pow __attribute__((__near__));	// Ϗo͓d


////////////////////////////////////////////////////////////////////////////////
// LCD\֌W

// ϐ

unsigned int shDcDc1RealVolt __attribute__((__near__));	// o͓d(hex)
unsigned int shDcDc1RealCurr __attribute__((__near__));	// o͓d(hex)
unsigned int shDcDc1RealPow __attribute__((__near__));	// o͓d(hex)

char cDcDc1RealVolt[6] __attribute__((__near__));	// o͓d
char cDcDc1RealCurr[6] __attribute__((__near__));	// o͓d
char cDcDc1RealPow[6] __attribute__((__near__));	// o͓d͕

// ׸

typedef struct tagDISPFLAGS{
	unsigned int fVolt:			1;			// d\
	unsigned int fCurr:			1;			// d\
	unsigned int fPow:			1;			// d͕\
}DD1_DISP_FLAGS;

DD1_DISP_FLAGS shDcDc1DispFlags __attribute__((__near__));	// \׸


///////////////////////////////////////////////////////////////////////////////
// RS232CʐM֌W

// ϐ

unsigned int shcTimeOut __attribute__((__near__));		// ѱėp

unsigned int shTransLen __attribute__((__near__));		// Mް
unsigned int shcTransmit __attribute__((__near__));		// M

char cTransBuff[BUFF_SIZE] __attribute__((__near__));	// Mޯ̧

// ׸

typedef struct tagUARTFLAGS{
	unsigned int fTransmit:			1;		// Mv׸
	unsigned int fTransIn:			1;		// M
	unsigned int fEnableSend:		1;		// M
}UART_FLAGS;

UART_FLAGS shUartFlags __attribute__((__near__));	// ʐM׸


///////////////////////////////////////////////////////////////////////////////
// Ҳٰ

unsigned int shCnt __attribute__((__near__));	// 


///////////////////////////////////////////////////////////////////////////////
//	֐錾

// ֐

void InitCLK(void);							// ۯ̏
void InitIO(void);							// IO߰Ă̏
void InitTM(void);							// TM1,2̏
void InitADC(void);							// ADC̏
void InitPWM1(void);						// PWM1̏
void InitInt(void);							// 荞݊֌W
void InitLCD(void);							// LCD̏
void InitUart(void);						// UART̏

// LCD̏֐

void WriteWait(unsigned int wt);			// wtmsec҂
void LCDBaseWrite(unsigned char data);		// ނ܂ް̏
void LCD4bitCmdWrite(unsigned char cmd);	// 4ޯĺނLCDɏ
void LCD8bitCmdWrite(unsigned char cmd);	// 8ޯĺނLCDɏ
void LCDAddressSet(unsigned char address);	// LCDް]ڽ̾
void LCD8bitDataWrite(unsigned char data);	// 8ޯްLCDɏ
void DispLCD(char* pt, unsigned char len);	// LCDɕ\

// SW1֐

void Sw1OnOffCheck(void);					// Sw1ON-OFFԂ

// DcDc1ް֐

void DcDc1ModeChange(void);					// DcDc1̉^]ԂύX
void DcDc1ModeCtrl(void);					// DcDc1^]ԂɉĐ

// ϒRl̎擾֌W

void SetVoltCurrRef(void);					// ϒRldEdɐݒ

// o͓dEo͓d擾֐

void SumDcDc1(void);						// DcDc1o͂Z
void CalcuAveDcDc1(void);					// DcDc1̏o͂̕ϒlvZ

// LCD\֌W֐

void DcDc1CreateDispData(void);				// DcDc1̕\ް\z
unsigned int CalcuRealVal(unsigned int val, unsigned int coef);	// DSPްlɕϊ
void ChangeValToStr(char* pt, unsigned int val);	// ɕϊ
void InsertPoint(char* pt, unsigned int place);		// _}
void DcDc1VoltDisp(unsigned int line);		// LCDDcDc1̏o͓d\
void DcDc1CurrDisp(unsigned int line);		// LCDDcDc1̏o͓d\
void LCDTitleDisp(void);					// ٕ\

// ʐM֌W֐

void DcDc1CreateTransData(void);			// DcDc1PCɑMް̍\z
void Transmit(void);						// ް̑M

// 荞݊֐

void __attribute__ ((__interrupt__, no_auto_psv)) _T1Interrupt(void);	// TM1荞
void __attribute__((__interrupt__, no_auto_psv)) _ADCP0Interrupt(void);	// ADω߱0荞
void __attribute__((__interrupt__, no_auto_psv)) _ADCP1Interrupt(void);	// ADϊ߱1荞
void __attribute__ ((__interrupt__, no_auto_psv)) _U1TXInterrupt(void);	// UARTM荞


